#ifndef EXCLUDE_H
#define EXCLUDE_H

#include "Drafo.h"

typedef std::vector<std::string> ITEM;

class ExcludeText {
    bool firstLine, serialNumber, whoText;
    const bool NO_SPLITTING;
    const int NEW_LINE_LENGTH;
    ITEM item;
    const std::string BELL, CLOSE_BRACKET, EMPTY, NEW_LINE;
    std::string error, EXCLUDE_TEXT, list_of_items, saveName, whose;
    std::stringstream *buffer;
    std::stringstream *combos;

    void add(std::string & s) {
        *combos << s << NEW_LINE;
    }

    void clear(std::string & s) {
        delete combos;
        combos = new std::stringstream();
        whose = s;
    }

    void listing() {
        std::string c = combos->str();
        *buffer << whose << NEW_LINE << c;
    }

    bool openSaveClose(std::string & fileName);
    bool readingToProduceArray();
    bool searchingItem(std::string & s);

public:
    ~ExcludeText() {
        delete buffer;
        delete combos;
    }

    std::string altered() const {
        return saveName;
    }

    std::string inquiry() const {
        return error;
    }

    bool altering(std::string & fileName);
    ExcludeText::ExcludeText(std::string & l, bool f, bool s, bool w);
};

#endif // EXCLUDE_H
