#include "Characte.h"

std::string Gaps::lotoLine() {
    using namespace std;

    bool trim = true;

    if(axial) {
        q = line.find(JIKU);
        if(q != string::npos) {
            trim = false;
        }

    }

    if(trim) {
        q = firstNumber(line);
        if(q == NOT_FOUND) {
            head = line;
            line = EMPTY;
            return head;
        } else {
            line = line.substr(q);
        }

    }

    string s = line;
    q = s.find(GAP);
    if(q != string::npos) {
        g = q;
        q = g + 1;
        s = line.substr(q);

        for(int i = 0; i < lotoMinusTwo; ++i) {
            q = s.find(GAP);
            if(q != string::npos) {
// "03 12 18 24 34 36 37 "
//    g  a                
                a = g + 1 + q;
                q = a + 1;
                s = line.substr(q);
                g = a;
                continue;
            } else {
                break;
            }

        }

    }

    if(q != string::npos) {
        ;
    } else {
// less than six gaps
        head = line;
        line = EMPTY;
        return head;
    }

// six gaps or more
// "03 12 18 24 34 36 37"
//                   g   
    q = g + 1;
    s = line.substr(q);
    q = s.find(GAP);
    if(q != string::npos) {
        ;
    } else { // six gaps
        head = line;
        line = EMPTY;
        return head;
    }

// another gap place
// "03 12 18 24 34 36 37 "
//                   g  a 
    a = g + 1 + q;
    q = g + 3;
    s = line.substr(q);
    q = firstNumber(s);
    if(q == NOT_FOUND) {
        q = s.find(QP);
        if(q != string::npos) {
            head = line;
            line = EMPTY;
            return head;
        } else {
// seven numbers
// "03 12 18 24 34 36 37 "
//                   g  a 
            head = line.substr(0, a); // "03 12 18 24 34 36 37"
            line = line.substr(a);
            if(line == GAP) {
                line = EMPTY;
            }

            return head;
        }

    }

// another number place
    n = g + 3 + q;
// "03 12 18 24 34 36 37 0"
//                   g  an 
    q = n + 1;
    s = line.substr(q);
    q = firstNumber(s);
    if(q == NOT_FOUND) {
// one-digit number
// "03 12 18 24 34 36 37 x2"
//                   g  a n 
        head = line.substr(0, n); // "03 12 18 24 34 36 37 x"
        line = line.substr(n);
        return head;
    }

// far number place
// "03 12 18 24 34 36 37 07 10 15 31 32 34 35"
//                   gb anf                   
    f = n + 1 + q;

    b = g + 1;
    bigger = line.substr(b, 2);
    stringstream ss(bigger);
    int big;
    ss >> big;

    smaller = line.substr(n, 2);
    stringstream sm(smaller);
    int little;
    sm >> little;

    if(big > little) {
        head = line.substr(0, n); // "03 12 18 24 34 36 37 "
        line = line.substr(n);
    } else { // big <= little
// more than seven numbers
        if(little > all) { /*
    "13 20 25 27 35 36 37 548"    
                      gb anf      */
            head = line.substr(0, n); // "13 20 25 27 35 36 37 "
            line = line.substr(n);
        } else {
// "03 12 18 24 33 34 36 37"
//                   gb anf
            head = line;
            line = EMPTY;
        }
    }

    return head;
}

std::string MultiLoto::lotoLine() {
    using namespace std;

    bool trim = true;
    const int SEPARATOR_SIZE = separator.length();

    if(axial) {
        q = line.find(JIKU);
        if(q != string::npos) {
            trim = false;
        }
    }

    if(trim) {
        q = firstNumber(line);
        if(q == NOT_FOUND) {
            head = line;
            line = EMPTY;
            return head;
        } else {
            line = line.substr(q);
        }

    }

    q = line.find(separator);
    if(q != string::npos) { // separator can be found.
        q += SEPARATOR_SIZE;
        head = line.substr(0, q); // "03 12 18 24 30 31 32 /"
        line = line.substr(q);
    } else {
        head = line;
        line = EMPTY;
    }

    return head;
}

int firstNumber(std::string & sequence) {
    const char * cString = sequence.c_str(); 
    int sequenceLength = sequence.length();

    if(sequenceLength == 0) {
        return NOT_FOUND;
    }

    int q = strcspn(cString, "0123456789");
    if(q == sequenceLength) {
        return NOT_FOUND;
    }

    return q;
}
