#ifndef zokoCSVH
#define zokoCSVH

#include <vcl\System.hpp>
#include <vcl\Windows.hpp>
#include <vcl\SysUtils.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Graphics.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <Grids.hpp>
#include <string>
#include "zoko.h"

class TOKBottomDlg : public TForm
{
__published:        
	TButton *OKBtn;
	TButton *CancelBtn;
	TBevel *Bevel1;
    TCheckBox *CheckBox1;
    THeaderControl *HeaderControl1;
    TStringGrid *StringGrid1;
    TLabel *Label1;
    TTimer *Timer1;
    void __fastcall OKBtnClick(TObject *Sender);
    void __fastcall HeaderControl1SectionResize(
          THeaderControl *HeaderControl, THeaderSection *Section);
    void __fastcall Timer1Timer(TObject *Sender);
    void __fastcall Label1Click(TObject *Sender);
private:
    bool checkBox, editor, firstLine, fullDate, fullLoto7, mark, noSplitting, onlyTwo, preedit, sectionResized, serialNumber, threeLinesUnited, whoText;
    const AnsiString COMBO, DATE, ID, BALLS, NAME, QP, RES_NUMBER;
    const std::string CLOSE_BRACKET, m0, m1, m2, m3, m4, m5, m6, m7, m8, m9, m10, m11, m12, m13, m14, m15, m16, m17, m18, ZERO;
    int balls, csv_h, csv_w, csv_x, csv_y, gridBottom, lines, narrow_name, rowCount, threshold_of_loto_7, threshold_of_date, threshold_of_name, untouched, whichCorner;
    std::string error, fileName, FULL_PATH_NAME, list_of_items, textName;
    std::string m[ MANAGE_TEXT_LINE_COUNT + 1 ];

    int width1(int ClientWidth);
    int width3(int ClientWidth);
    int width6(int ClientWidth);
    void stringArrayToValues();
    void tracking();
public:
    std::string inquiry() const {
        return error;
    }

    std::string saved() const {
        return textName;
    }

    bool readCSV(std::string & fileName);
    bool readManageText();
	virtual __fastcall TOKBottomDlg(TComponent* AOwner);
    void setting(std::string & f, int r);
};

extern PACKAGE TOKBottomDlg *OKBottomDlg;
int integerFromString(std::string & s);

#endif    
