//---------------------------------------------------------------------------

#ifndef editorMainH
#define editorMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <Clipbrd.hpp>
#include "Editor.h"
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include "Editor.h"

enum AIM {
    NO_AIM,
    GO,
    SWELL
};

enum REVERSE_COMMAND {
    NO_OPERATION,
    UNDO_BS,
    UNDO_CLEAR,
    UNDO_CLIP,
    UNDO_CUT,
    UNDO_CUT_ADD_MARGIN,
    UNDO_DELETE,
    UNDO_GO,
    UNDO_INSERT,
    UNDO_MARGIN,
    UNDO_SEVER,
    UNDO_SHRINK,
    UNDO_SWELL,
    UNDO_START
};

typedef struct EDITOR_MEMO EDITOR_MEMO;
struct EDITOR_MEMO {
    AnsiString cellNumber;
    double versionNumber;
    std::string fullPathName, line_1;
};

typedef struct UNDO_DATA UNDO_DATA;
struct UNDO_DATA {
    char data[IMAGE_COUNT];
    enum REVERSE_COMMAND reverse_command;
    int cell_x, previous_aim, previous_block_x, previous_x, size_bytes;
};

//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE Ǘ̃R|[lg
    TMainMenu *MainMenu1;
    TMenuItem *File1;
    TMenuItem *Copy1;
    TMenuItem *N1;
    TMenuItem *Exit1;
    TMenuItem *Save1;
    TMenuItem *Go1;
    TMenuItem *End1;
    TMenuItem *Hide1;
    TMenuItem *Home1;
    TMenuItem *Jump1;
    TMenuItem *Left1;
    TMenuItem *Right1;
    TMenuItem *Show1;
    TMenuItem *Edit1;
    TMenuItem *Sever1;
    TMenuItem *N2;
    TMenuItem *BS1;
    TMenuItem *Capital1;
    TMenuItem *A1;
    TMenuItem *B1;
    TMenuItem *C1;
    TMenuItem *D1;
    TMenuItem *E1;
    TMenuItem *F1;
    TMenuItem *G1;
    TMenuItem *H1;
    TMenuItem *I1;
    TMenuItem *Clipboard1;
    TMenuItem *Delete1;
    TMenuItem *Insert1;
    TMenuItem *Minus1;
    TMenuItem *Margin1;
    TMenuItem *Space1;
    TMenuItem *Undo1;
    TMenuItem *White1;
    TMenuItem *Block1;
    TMenuItem *Cut1;
    TMenuItem *N3;
    TMenuItem *Shrink1;
    TMenuItem *Swell1;
    TMenuItem *Help1;
    TPanel *Panel1;
    TImage *Image1;
    TImage *Image2;
    TImage *Image3;
    TImage *Image4;
    TImage *Image5;
    TImage *Image6;
    TImage *Image7;
    TImage *Image8;
    TImage *Image9;
    TImage *Image10;
    TImage *Image11;
    TImage *Image12;
    TImage *Image13;
    TImage *Image14;
    TImage *Image15;
    TImage *Image16;
    TImage *Image17;
    TImage *Image18;
    TImage *Image19;
    TImage *Image20;
    TImage *Image21;
    TImage *Image22;
    TImage *Image23;
    TImage *Image24;
    TImage *Image25;
    TImage *Image26;
    TImage *Image27;
    TImage *Image28;
    TImage *Image29;
    TImage *Image30;
    TImage *Image31;
    TImage *Image32;
    TImage *Image33;
    TImage *Image34;
    TImage *Image35;
    TImage *Image36;
    TImage *Image37;
    TImage *Image38;
    TImage *Image39;
    TImage *Image40;
    TImage *Image41;
    TImage *Image42;
    TImage *Image43;
    TImage *Image44;
    TImage *Image45;
    TImage *Image46;
    TImage *Image47;
    TImage *Image48;
    TImage *Image49;
    TImage *Image50;
    TImage *Image51;
    TImage *Image52;
    TImage *Image53;
    TImage *Image54;
    TImage *Image55;
    TImage *Image56;
    TImage *Image57;
    TImage *Image58;
    TImage *Image59;
    TImage *Image60;
    TImage *Image61;
    TImage *Image62;
    TImage *Image63;
    TImage *Image64;
    TImage *Image65;
    TImage *Image66;
    TImage *Image67;
    TImage *Image68;
    TImage *Image69;
    TImage *Image70;
    TImage *Image71;
    TImage *Image72;
    TImage *Image73;
    TImage *Image74;
    TImage *Image75;
    TImage *Image76;
    TImage *Image77;
    TImage *Image78;
    TImage *Image79;
    TImage *Image80;
    TImage *Image81;
    TImage *Image82;
    TImage *Image83;
    TImage *Image84;
    TImage *Image85;
    TImage *Image86;
    TImage *Image87;
    TImage *Image88;
    TImage *Image89;
    TImage *Image90;
    TImage *Image91;
    TImage *Image92;
    TImage *Image93;
    TImage *Image94;
    TImage *Image95;
    TImage *Image96;
    TImage *Image97;
    TImage *Image98;
    TImage *Image99;
    TImage *Image100;
    TMenuItem *Wide1;
    TMenuItem *Version1;
    TImage *Image101;
    TMenuItem *Version2;
    TMenuItem *J1;
    TTimer *Timer1;
    TMenuItem *Inquiry1;
    TPanel *Panel2;
    TLabel *Label1;
    TMenuItem *Aquamarine1;
    TMenuItem *Yellow1;
    TPaintBox *PaintBox1;
    TPaintBox *PaintBox2;
    TPaintBox *PaintBox3;
    TPaintBox *PaintBox4;
    void __fastcall Exit1Click(TObject *Sender);
    void __fastcall Version1Click(TObject *Sender);
    void __fastcall Version2Click(TObject *Sender);
    void __fastcall Wide1Click(TObject *Sender);
    void __fastcall Show1Click(TObject *Sender);
    void __fastcall Left1Click(TObject *Sender);
    void __fastcall Right1Click(TObject *Sender);
    void __fastcall Undo1Click(TObject *Sender);
    void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall Copy1Click(TObject *Sender);
    void __fastcall Hide1Click(TObject *Sender);
    void __fastcall Home1Click(TObject *Sender);
    void __fastcall End1Click(TObject *Sender);
    void __fastcall Delete1Click(TObject *Sender);
    void __fastcall BS1Click(TObject *Sender);
    void __fastcall Minus1Click(TObject *Sender);
    void __fastcall Space1Click(TObject *Sender);
    void __fastcall A1Click(TObject *Sender);
    void __fastcall B1Click(TObject *Sender);
    void __fastcall C1Click(TObject *Sender);
    void __fastcall D1Click(TObject *Sender);
    void __fastcall E1Click(TObject *Sender);
    void __fastcall F1Click(TObject *Sender);
    void __fastcall G1Click(TObject *Sender);
    void __fastcall H1Click(TObject *Sender);
    void __fastcall I1Click(TObject *Sender);
    void __fastcall J1Click(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall Shrink1Click(TObject *Sender);
    void __fastcall Swell1Click(TObject *Sender);
    void __fastcall Cut1Click(TObject *Sender);
    void __fastcall Insert1Click(TObject *Sender);
    void __fastcall Image1Click(TObject *Sender);
    void __fastcall Image100Click(TObject *Sender);
    void __fastcall Clipboard1Click(TObject *Sender);
    void __fastcall Sever1Click(TObject *Sender);
    void __fastcall Margin1Click(TObject *Sender);
    void __fastcall White1Click(TObject *Sender);
    void __fastcall Save1Click(TObject *Sender);
    void __fastcall Timer1Timer(TObject *Sender);
    void __fastcall Inquiry1Click(TObject *Sender);
    void __fastcall Jump1Click(TObject *Sender);
    void __fastcall Aquamarine1Click(TObject *Sender);
    void __fastcall Yellow1Click(TObject *Sender);
    void __fastcall PaintBox1Click(TObject *Sender);
    void __fastcall PaintBox2Click(TObject *Sender);
    void __fastcall PaintBox3Click(TObject *Sender);
    void __fastcall PaintBox4Click(TObject *Sender);
private:	// [U[錾
    AnsiString cellNumber;
    bool aquamarine, blockMode, editMode, goMode, undoClosed, versionCaption, widePane;
    bool check[ LOTO_6_COUNT + 1 ];
    BufferSplit *bs;
    char record[RECORD_SIZE];
    const AnsiString EDITOR_MENU, GREEN_SQUARE, NEW_LINE, RED_SQUARE, WHITE_SQUARE;
    const std::string CLOSE_BRACKET, EMPTY;
    double versionNumber;
    int aim, anchor, block_x, cell_x, cursor, jumpTo, unhandled, recordNumber;
    std::ifstream getUndo;
    std::ofstream putUndo;
    std::string CAPITAL_A, CAPITAL_B, CAPITAL_C, CAPITAL_D, CAPITAL_E, CAPITAL_F, CAPITAL_G, CAPITAL_H, CAPITAL_I, CAPITAL_J, copied, error, fullPathName, GAP, line_1, MINUS, NUMBER_0, NUMBER_1, NUMBER_2, NUMBER_3, NUMBER_4, NUMBER_5, NUMBER_6, NUMBER_7, NUMBER_8, NUMBER_9, statusBarText, timeNameText;
    TImage *image[ IMAGE_COUNT + 1 ];
    TLabel *label[ LABEL_COUNT + 1 ];
    UNDO_DATA ud;
    union RECORD_NUMBER {
        char number_bytes[4];
        int record_number;
    } r;

    bool openUndo();
    bool readManageText();
    bool readUndoBin();
    bool saveLine1();
    bool undoThat();
    std::string clearBlock();
    std::string copyHandler();
    std::string cutAddMargin();
    std::string cutHandler();
    std::string deleted(std::string & old_gap_status_bar_text);
    std::string inserted(std::string & character, std::string & old_gap_status_bar_text);
    std::string startEditing(std::string & character, std::string & s);
    std::string startEditing(std::string & s, int count, bool margin);
    std::string trimmed(std::string & line);
    std::string whiteHandler();
    void acquireDataFromClipBoard();
    void addUndoData();
    void aquaSquare(TImage *image);
    void blackCharacter(TImage *image, std::string gap_added, int cell_x);
    void BShandler();
    void clipping();
    void cursorLine();
    void deleteHandler();
    void endEditing();
    void endHandler();
    void hideHandler();
    void homeHandler();
    void insertHandler(std::string & s);
    void jumpHandler(int jumpTo);
    void leftHandler();
    void marginHandler();
    void no_swell();
    void previousSwell(int previous_anchor);
    void redSquare(TImage *image);
    void repeat_inserting(std::string & data);
    void rightHandler();
    void severHandler();
    void showHandler();
    void shrinkHandler();
    void sittingStill();
    void startBlock();
    void statusBarMessage(std::string & s);
    void swellHandler();
    void undo_insert();
    void undoBS();
    void undoClear();
    void undoClip();
    void undoCut();
    void undoCutAddMargin();
    void undoDelete();
    void undoGo();
    void undoMargin();
    void undoSever();
    void undoShrink();
    void undoStart();
    void undoSwell();
    void whiteCharacter(TImage *image, std::string gap_added, int cell_x);
    void whitenBlacken(std::string & old_gap_added, std::string & gap_added, int OLD_GAP_ADDED_LENGTH, int GAP_ADDED_LENGTH);
    void whiteSquare(TImage *image);
public:		// [U[錾
    __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
