#ifndef BALL_COLOR_SET_H
#define BALL_COLOR_SET_H

#pragma warn -8006 // Borland C++ 5.5.1 for Win32
#pragma warn -8018

#define BALL_SET_ARRAY 3 // ballSet[][][3]
#define COLOR_COUNT 7
#define LOTO_6_COUNT 43
#define UNASSIGNED -1
#include "Mark.h"

enum BALL_COLOR {RED, YELLOW, BEIGE, GREEN, BLUE, NAVY, PURPLE, BALL_COLOR_COUNT};
enum BALL_SET {A_SET, B_SET, C_SET, D_SET, E_SET, F_SET, G_SET, H_SET, I_SET, J_SET, BALL_SET_COUNT};

typedef std::map<std::string, int> NAME_NUMBER;

class BallColorSet {
    bool reality[ LOTO_6_COUNT + 1 ][BALL_COLOR_COUNT][BALL_SET_COUNT];
    const std::string A_J, B01, B02, B03, B04, B05, B06, B07, B08, B09, B10, B11, B12, B13, B14, B15, B16, B17, B18, B19, B20, B21, B22, B23, B24, B25, B26, B27, B28, B29, B30, B31, B32, B33, B34, B35, B36, B37, B38, B39, B40, B41, B42, B43, EMPTY, GAP, SLASH_GAP;
    int ball_color[ LOTO_6_COUNT + 1 ][BALL_SET_COUNT];
    int ballSet[ LOTO_6_COUNT + 1 ][BALL_COLOR_COUNT][BALL_SET_ARRAY];
    NAME_NUMBER ballNameNumber;
    std::string ball[ LOTO_6_COUNT + 1 ];

    void addingToBallSetArray(int b, int c, int s);
    void setting();

public:
    ~BallColorSet(){}

    BallColorSet();
    int ballColor(std::string & c, int s);
    std::string ballSetList(int b, int c);
};

#endif // BALL_COLOR_SET_H
