#ifndef DIVIDING_H
#define DIVIDING_H

#include <string>
#include <vector>

class Dividable {
	char r[2];

protected:
    int FIELD_COUNT, k, lineLength;
    std::string a0, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, c, g, QUOTE;

	bool isDigit(std::string & h) {
		strcpy(r, h.c_str() );
		if('0' <= r[0] && r[0] <= '9') {
			return true;
		}

		return false;
	}

public:
    void setting(std::string & line) {
    	const std::string qu("\"");

		r[0] = 0;
		r[1] = 0;
        k = 0;
		FIELD_COUNT = 12;
        lineLength = line.length();
        QUOTE = qu;
    }

	int fieldCount () const {
		return FIELD_COUNT;
	}

    std::string a(int);
    virtual ~Dividable(){}
    virtual std::string scanningDigits(std::string &) = 0;
    virtual std::string scanning(std::string &) = 0;
};

class Dividing : public Dividable {
    const std::string GAP;
    std::string scanningDigits(std::string &);
    std::string scanning(std::string &);

public:
    Dividing(std::string & s, bool digits): GAP(" ") {
        setting(s);

		if(digits) {
	        a0 = scanningDigits(s);
	        a1 = scanningDigits(s);
	        a2 = scanningDigits(s);
	        a3 = scanningDigits(s);
	        a4 = scanningDigits(s);
	        a5 = scanningDigits(s);
	        a6 = scanningDigits(s);
	        a7 = scanningDigits(s);
	        a8 = scanningDigits(s);
	        a9 = scanningDigits(s);
	        a10 = scanningDigits(s);
	        a11 = scanningDigits(s);
		} else {
	        a0 = scanning(s);
	        a1 = scanning(s);
	        a2 = scanning(s);
	        a3 = scanning(s);
	        a4 = scanning(s);
	        a5 = scanning(s);
	        a6 = scanning(s);
	        a7 = scanning(s);
	        a8 = scanning(s);
	        a9 = scanning(s);
	        a10 = scanning(s);
	        a11 = scanning(s);
		}

    }

    Dividing(std::string & s): GAP(" ") {
        setting(s);
        a0 = scanning(s);
        a1 = scanning(s);
        a2 = scanning(s);
        a3 = scanning(s);
        a4 = scanning(s);
        a5 = scanning(s);
        a6 = scanning(s);
        a7 = scanning(s);
        a8 = scanning(s);
        a9 = scanning(s);
        a10 = scanning(s);
        a11 = scanning(s);
    }

    ~Dividing(){}
};

class DividingCSV : public Dividable {
    const std::string COMMA;
    std::string scanningDigits(std::string &);
    std::string scanning(std::string &);

public:
    DividingCSV(std::string & s, bool digits): COMMA(",") {
        setting(s);

		if(digits) {
	        a0 = scanningDigits(s);
	        a1 = scanningDigits(s);
	        a2 = scanningDigits(s);
	        a3 = scanningDigits(s);
	        a4 = scanningDigits(s);
	        a5 = scanningDigits(s);
	        a6 = scanningDigits(s);
	        a7 = scanningDigits(s);
	        a8 = scanningDigits(s);
	        a9 = scanningDigits(s);
	        a10 = scanningDigits(s);
	        a11 = scanningDigits(s);
		} else {
	        a0 = scanning(s);
	        a1 = scanning(s);
	        a2 = scanning(s);
	        a3 = scanning(s);
	        a4 = scanning(s);
	        a5 = scanning(s);
	        a6 = scanning(s);
	        a7 = scanning(s);
	        a8 = scanning(s);
	        a9 = scanning(s);
	        a10 = scanning(s);
	        a11 = scanning(s);
		}

    }

    DividingCSV(std::string & s): COMMA(",") {
        setting(s);
        a0 = scanning(s);
        a1 = scanning(s);
        a2 = scanning(s);
        a3 = scanning(s);
        a4 = scanning(s);
        a5 = scanning(s);
        a6 = scanning(s);
        a7 = scanning(s);
        a8 = scanning(s);
        a9 = scanning(s);
        a10 = scanning(s);
        a11 = scanning(s);
    }

    ~DividingCSV(){}
};

class FormingVector : public Dividable {
    const std::string GAP;
    std::string scanningDigits(std::string &);
    std::string scanning(std::string &);

public:
	std::vector<std::string> v;

    FormingVector(std::string & s, bool digits): GAP(" ") {
		using namespace std;

        setting(s);

		if(digits) {
	        a0 = scanningDigits(s);
			v.push_back(a0);
	        a1 = scanningDigits(s);
			v.push_back(a1);
	        a2 = scanningDigits(s);
			v.push_back(a2);
	        a3 = scanningDigits(s);
			v.push_back(a3);
	        a4 = scanningDigits(s);
			v.push_back(a4);
	        a5 = scanningDigits(s);
			v.push_back(a5);
	        a6 = scanningDigits(s);
			v.push_back(a6);
	        a7 = scanningDigits(s);
			v.push_back(a7);
	        a8 = scanningDigits(s);
			v.push_back(a8);
	        a9 = scanningDigits(s);
			v.push_back(a9);
	        a10 = scanningDigits(s);
			v.push_back(a10);
	        a11 = scanningDigits(s);
			v.push_back(a11);
		} else {
	        a0 = scanning(s);
			v.push_back(a0);
	        a1 = scanning(s);
			v.push_back(a1);
	        a2 = scanning(s);
			v.push_back(a2);
	        a3 = scanning(s);
			v.push_back(a3);
	        a4 = scanning(s);
			v.push_back(a4);
	        a5 = scanning(s);
			v.push_back(a5);
	        a6 = scanning(s);
			v.push_back(a6);
	        a7 = scanning(s);
			v.push_back(a7);
	        a8 = scanning(s);
			v.push_back(a8);
	        a9 = scanning(s);
			v.push_back(a9);
	        a10 = scanning(s);
			v.push_back(a10);
	        a11 = scanning(s);
			v.push_back(a11);
		}

    }

    FormingVector(std::string & s): GAP(" ") {
		using namespace std;

        setting(s);
        a0 = scanning(s);
		v.push_back(a0);
        a1 = scanning(s);
		v.push_back(a1);
        a2 = scanning(s);
		v.push_back(a2);
        a3 = scanning(s);
		v.push_back(a3);
        a4 = scanning(s);
		v.push_back(a4);
        a5 = scanning(s);
		v.push_back(a5);
        a6 = scanning(s);
		v.push_back(a6);
        a7 = scanning(s);
		v.push_back(a7);
        a8 = scanning(s);
		v.push_back(a8);
        a9 = scanning(s);
		v.push_back(a9);
        a10 = scanning(s);
		v.push_back(a10);
        a11 = scanning(s);
		v.push_back(a11);
    }

    ~FormingVector(){}
};

#endif // DIVIDING_H 
