#include "Mark.h"

int MissingBonus::stringToInteger(std::string & data) {
    using namespace std;

    int value;
    stringstream ss(data);
    ss >> value;
    return value;
}

MissingBonus::MissingBonus(MissingBonus *mb): HYPHEN("-") {
    b = mb->bonusBallNumber();
    bonus = mb->bonusBallNumber();
    m = mb->missingBallNumber();
    missing = mb->missingBallNumber();
    missingBonus = missing + HYPHEN + bonus;
}

MissingBonus::MissingBonus(std::string & bo, std::string & mi): HYPHEN("-") {
    b = stringToInteger(bo);
    bonus = bo;
    m = stringToInteger(mi);
    missing = mi;
    missingBonus = missing + HYPHEN + bonus;
}
