#include "Optional.h"

extern MANAGE_MEMO *mm;

bool Optional::readManageText() {
    using namespace std;

    char c[BUFFER_SIZE];
    string *p = new string("");
    ifstream in( FULL_PATH_NAME.c_str() );
    if( in.fail() ) {
        error = "e42: ifstream in( " + FULL_PATH_NAME + CLOSE_BRACKET;
        createErrorText(error);
        return false;
    }

    m[0] = FULL_PATH_NAME;
    for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1 ) {
        if( in.getline(c, BUFFER_SIZE) ) {
            delete p;
            p = new string(c);
            m[line] = *p;
        } else {
            break;
        }

    }

    in.close();
    delete p;
    return true;
}

OPTIONAL_CODE Optional::readOptionalText() {
    using namespace std;

    char c[BUFFER_SIZE];
    string *p = new string("");
    ifstream in( OPTIONAL_TEXT.c_str() );
    if( in.fail() ) {
        error = "e43: ifstream in( " + OPTIONAL_TEXT + CLOSE_BRACKET;
        createErrorText(error);
        return oc;
    }

    for(int i = 0; i < OPTIONAL_TEXT_LINE_COUNT; ++i) {
        if( in.getline(c, BUFFER_SIZE) ) {
            delete p;
            p = new string(c);
            oc.optional[i] = *p;
        } else {
            break;
        }

    }

    in.close();
    delete p;
    return oc;
}

Optional::Optional(std::string & f): BALLS(4), CLOSE_BRACKET(" )"), EMPTY(""), EXCLUDE_TEXT("exclude.txt"), GAP_TAB(" \t"), m0(""), m1("who.txt"), m2("exclude.txt"), m3("2"), m4("0"), m5("1"), m6("0"), m7("1"), m8("5000"), m9("1"), m10("0"), m11("0"), m12("1"), m13("0"), m14("20"), m15("20"), m16("800"), m17("600"), m18("1"), OP("optional.txt"), ZERO("0") {
    FULL_PATH_NAME = f;
    m[0] = m0; m[1] = m1; m[2] = m2; m[3] = m3; m[4] = m4; m[5] = m5; m[6] = m6; m[7] = m7; m[8] = m8; m[9] = m9; m[10] = m10; m[11] = m11; m[12] = m12; m[13] = m13; m[14] = m14; m[15] = m15; m[16] = m16; m[17] = m17; m[18] = m18;
    for(int i = 0; i < OPTIONAL_TEXT_LINE_COUNT; ++i) {
        oc.optional[i] = EMPTY;
    }

    OPTIONAL_TEXT = OP;
}

Optional::Optional(std::string & f, std::string & o): BALLS(4), CLOSE_BRACKET(" )"), EMPTY(""), EXCLUDE_TEXT("exclude.txt"), GAP_TAB(" \t"), m0(""), m1("who.txt"), m2("exclude.txt"), m3("2"), m4("0"), m5("1"), m6("0"), m7("1"), m8("5000"), m9("1"), m10("0"), m11("0"), m12("1"), m13("0"), m14("20"), m15("20"), m16("800"), m17("600"), m18("1"), OP("optional.txt"), ZERO("0") {
    FULL_PATH_NAME = f;
    m[0] = m0; m[1] = m1; m[2] = m2; m[3] = m3; m[4] = m4; m[5] = m5; m[6] = m6; m[7] = m7; m[8] = m8; m[9] = m9; m[10] = m10; m[11] = m11; m[12] = m12; m[13] = m13; m[14] = m14; m[15] = m15; m[16] = m16; m[17] = m17; m[18] = m18;
    for(int i = 0; i < OPTIONAL_TEXT_LINE_COUNT; ++i) {
        oc.optional[i] = EMPTY;
    }

    OPTIONAL_TEXT = o;
}

void Optional::command(std::string & commandLine) {
    using namespace std;

    bool destroyWhoText;
    int q;
    Numbered *n = new Numbered("");
    string argument;
    const string BONUS("-b");
    const string BONUS_3("-c3b");
    const string BONUS_6("-c6b");
    const string COUNT("-c");
    const string CSV("--csv");
    const string EMPTY("");
    const string EXCLUDE("-e");
    const string EXCLUDE_TEXT("exclude.txt");
    const string DIAGONAL("-d");
    const string NO_EDITING("-e-");
    const string NO_PREEDITING("-p-");
    const string NO_REMOVING("-r-");
    const string NO_SPLITTING("-s-");
    const string OVERWRITE("-o");
    const string QUIT("-q");
    const string REMOVE_LINE_1("-1-");
    const string TABLE("-a");
    const string THREE_LINES_UNITED("-3");

    balls = BALLS;
    countBonus = false;
    csv = false;
    csv_x = 20;
    csv_y = 20;
    csv_w = 800;
    csv_h = 600;
    fileName = WHO_TEXT;
    firstLine = true;
    list_of_items = EXCLUDE_TEXT;
    noSplitting = false;
    preedit = true;
    quit = false;
    rowCount = CSV_LINE_COUNT;
    serialNumber = true;
    threeLinesUnited = false;
    whichCorner = 0; // centering
    whoText = true;

    ifstream file( FULL_PATH_NAME.c_str() );
    if ( file.fail() ) { // MANAGE_TEXT
        cerr << "Producing " << FULL_PATH_NAME << endl;

// Creating MANAGE_TEXT
        ofstream manage_text( FULL_PATH_NAME.c_str() );
        for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1 ) {
            manage_text << m[line] << endl;
        }

    }

    readManageText();

    balls = integerFromString(m[3]);
    const int based_on_m3 = balls;
    fileName = m[1];
    list_of_items = m[2];

    editor = (ZERO == m[4]) ? false : true;
    firstLine = (ZERO == m[5]) ? false : true;
    noSplitting = (ZERO == m[6]) ? false : true;
    preedit = (ZERO == m[7]) ? false : true;
    rowCount = integerFromString(m[8]);
    serialNumber = (ZERO == m[9]) ? false : true;
    mark = (ZERO == m[10]) ? false : true;
    destroyWhoText = (ZERO == m[11]) ? false : true;
    threeLinesUnited = (ZERO == m[12]) ? false : true;
    whichCorner = integerFromString(m[13]);
    const int based_on_m13 = whichCorner;

    csv_x = integerFromString(m[14]);
    csv_y = integerFromString(m[15]);
    csv_w = integerFromString(m[16]);
    csv_h = integerFromString(m[17]);
    checkBox = (ZERO == m[18]) ? false : true;

    char r[SMALL_BUFFER_SIZE];
    Dividing d(commandLine);
    const int FIELD_COUNT = d.fieldCount();
    for(int i = 1; i < FIELD_COUNT; ++i) {
        argument = d.a(i);
        if( argument.length() == 0 ) {
            break;
        }

        if(BONUS_3 == argument) {
            balls = 3;
            countBonus = true;
        } else if(BONUS_6 == argument) {
            balls = 6;
            countBonus = true;
        } else if(CSV == argument) {
            csv = true;
        } else if(EXCLUDE == argument) {
            list_of_items = EXCLUDE_TEXT;
        } else if(NO_EDITING == argument) {
            preedit = false;
        } else if(NO_PREEDITING == argument) {
            preedit = false;
        } else if(NO_SPLITTING == argument) {
            noSplitting = true;
        } else if(OVERWRITE == argument) {
            destroyWhoText = true;
        } else if(QUIT == argument) {
            quit = true;
        } else if(REMOVE_LINE_1 == argument) {
            firstLine = false;
        } else if(TABLE == argument) {
            csv = true;
        } else if(THREE_LINES_UNITED == argument) { // The web browser may divide a date line into three lines, which shall be united to form the date line.
            threeLinesUnited = true;
        } else {
            if(whoText) {
                fileName = argument;
                whoText = false;
            } else {
                q = argument.find(BONUS);
                if(q != string::npos) {
                    delete n;
                    strcpy(r, argument.c_str() );
                    n = new Numbered(r);
                    balls = n->number();
                    countBonus = true;
                    if( n->parameter() == BONUS ) {
                        continue;
                    }

                    balls = based_on_m3;
                    countBonus = false;
                }

                q = argument.find(COUNT);
                if(q != string::npos) {
                    delete n;
                    strcpy(r, argument.c_str() );
                    n = new Numbered(r);
                    balls = n->number();
                    if( n->parameter() == COUNT ) {
                        continue;
                    }

                    balls = based_on_m3;
                }

                q = argument.find(DIAGONAL);
                if(q != string::npos) {
                    delete n;
                    strcpy(r, argument.c_str() );
                    n = new Numbered(r);
                    whichCorner = n->number();
                    if( n->parameter() == DIAGONAL ) {
                        continue;
                    }

                    whichCorner = based_on_m13;
                }

                list_of_items = argument;
            }

        }

    }

    delete n;
    whoText = destroyWhoText;

    mm->balls = balls;
    mm->countBonus = countBonus;
    mm->checkBox = checkBox;
    mm->csv = csv;
    mm->editor = editor;
    mm->fileName = fileName;
    mm->firstLine = firstLine;
    mm->list_of_items = list_of_items;
    mm->mark = mark;
    mm->noSplitting = noSplitting;
    mm->pleaseCheck = true;
    mm->preedit = preedit;
    mm->quit = quit;
    mm->rowCount = rowCount;
    mm->serialNumber = serialNumber;
    mm->threeLinesUnited = threeLinesUnited;
    mm->whichCorner = whichCorner;
    mm->whoText = whoText;
}
