#ifndef OPTIONAL_H
#define OPTIONAL_H

#define BUFFER_SIZE 2048
#define CSV_LINE_COUNT 5000
#define MANAGE_TEXT_LINE_COUNT 18
#define OPTIONAL_TEXT_LINE_COUNT 36
#define SMALL_BUFFER_SIZE 64
#define WHO_TEXT "who.txt"
#include <fstream>
#include <string>
#include "Dividing.h"
#include "Numbered.h"
#include "RannuText.h"

typedef struct OPTIONAL_CODE OPTIONAL_CODE;
struct OPTIONAL_CODE {
    std::string optional[OPTIONAL_TEXT_LINE_COUNT];
};

class Optional {
    const int BALLS;
    const std::string CLOSE_BRACKET, EMPTY, EXCLUDE_TEXT, GAP_TAB, m0, m1, m2, m3, m4, m5, m6, m7, m8, m9, m10, m11, m12, m13, m14, m15, m16, m17, m18, OP, ZERO;

    bool checkBox, countBonus, csv, editor, firstLine, mark, noSplitting, preedit, quit, serialNumber, threeLinesUnited, whoText;
    int balls, csv_h, csv_w, csv_x, csv_y, NEW_LINE_LENGTH, rowCount, whichCorner;
    OPTIONAL_CODE oc;
    std::string fileName, error, FULL_PATH_NAME, list_of_items, NEW_LINE, OPTIONAL_TEXT;
    std::string m[ MANAGE_TEXT_LINE_COUNT + 1 ];

    bool readManageText();

public:
    Optional(std::string & f);
    Optional(std::string & f, std::string & o);
    OPTIONAL_CODE readOptionalText();
    void command(std::string & commandLine); // mm->noSplitting = noSplitting; mm->preedit = preedit; mm->ticketForm = ticketForm; for example
};

int integerFromString(std::string & data);
void createErrorText(std::string & messages);

#endif // OPTIONAL_H
