#include "kopicLog.h"

char *random_number;
extern int untouched;
extern MANAGE_MEMO *mm;

namespace {
    char two_digit_number[0x100][0x100];
    const std::string B01("01,"); const std::string B02("02,"); const std::string B03("03,"); const std::string B04("04,"); const std::string B05("05,"); const std::string B06("06,"); const std::string B07("07,"); const std::string B08("08,"); const std::string B09("09,"); const std::string B10("10,"); 
    const std::string B11("11,"); const std::string B12("12,"); const std::string B13("13,"); const std::string B14("14,"); const std::string B15("15,"); const std::string B16("16,"); const std::string B17("17,"); const std::string B18("18,"); const std::string B19("19,"); const std::string B20("20,"); 
    const std::string B21("21,"); const std::string B22("22,"); const std::string B23("23,"); const std::string B24("24,"); const std::string B25("25,"); const std::string B26("26,"); const std::string B27("27,"); const std::string B28("28,"); const std::string B29("29,"); const std::string B30("30,"); 
    const std::string B31("31,"); const std::string B32("32,"); const std::string B33("33,"); const std::string B34("34,"); const std::string B35("35,"); const std::string B36("36,"); const std::string B37("37,"); const std::string B38("From,"); const std::string B39("Log,"); const std::string B40("Repeat,"); 
    const std::string B41("Setting,"); 
    int many_one[ ALL + 1 ] = {20, 11, 12, 13, 14, 15, 16, 17, 18, 19, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 20, 21, 22, 23, 24, 25, 26, 27};
    std::string d[ SETTING_LINE + 1 ];
}

bool fullSwing(char *file_name) {
    using namespace std;

    char c[BUFFER_SIZE];
    ifstream file(file_name);
    if( file.fail() ) {
        ofstream error_text(ERROR_TEXT);
        error_text << file_name << endl;
        return false;
    }

    const string NEW_LINE("\n");
    int maximum = 0;
    int v[ SETTING_LINE + 1 ];
    int line = 0;
    string log(KOPIC_LOG_TEXT);
    v[line] = 0;
    for(line = 1; line < FROM_LINE; line += 1 ) {
        if( file.getline(c, BUFFER_SIZE) ) {
            v[line] = secondField(c, &log);
            if(v[line] > maximum) {
                maximum = v[line];
            }

        } else {
            ofstream error_text(ERROR_TEXT);
            error_text << "ifstream file(KOPIC_CSV)" << endl;
            error_text << "line = " << line << endl;
            return false;
        }

    }

    for( ; line <= SETTING_LINE; line += 1 ) {
        if( file.getline(c, BUFFER_SIZE) ) {
            v[line] = secondField(c, &log);
        } else {
            ofstream error_text(ERROR_TEXT);
            error_text << "ifstream file(KOPIC_CSV)" << endl;
            error_text << "line = " << line << endl;
            return false;
        }

    }

    file.close();
    const double XBM_WIDTH_VALUE = (double)XBM_WIDTH;
    double maximum_value = (double)maximum;
    double value;
    int n;
    stringstream os;
    for(line = 1; line < FROM_LINE; line += 1 ) {
        value = (double)v[line];
        value = ( XBM_WIDTH_VALUE - 1.0 ) * value/maximum_value;
        n = (int)floor(value);
        os << d[line] << n << NEW_LINE;
        v[line] = n;
    }

    os << d[FROM_LINE] << v[FROM_LINE] << NEW_LINE;
    os << d[LOG_LINE] << log << NEW_LINE;
    os << d[REPEAT_LINE] << v[REPEAT_LINE] << NEW_LINE;
    os << d[SETTING_LINE] << v[SETTING_LINE] << NEW_LINE;
    string s = os.str();

    ofstream csv_file(KOPIC_CSV);
    csv_file << s;
    csv_file.close();
    untouched = modified_file(KOPIC_CSV);

    const string SHARP("#");
    const string SPACE(" ");
    int k;
    ofstream text(KOPIC_TEXT);
    for(line = 1; line < FROM_LINE; line += 1 ) {
        for(k = 0; k < v[line]; ++k) {
            text << SPACE;
        }

        text << SHARP;
        ++k;
        for( ; k < XBM_WIDTH; ++k) {
            text << SPACE;
        }

        text << endl;
    }

    return true;
}

bool Pickable::readKopicCsv() {
    using namespace std;

    char *stop;
    char buffer[BUFFER_SIZE];
    const string COMMA(",");
    unsigned int q;
    string *p = new string("");
    string head, body, s, tail;

// Reading KOPIC_CSV to produce a weight array
    ifstream csv_file(KOPIC_CSV);
    if( csv_file.fail() ) {
        ofstream file(ERROR_TEXT);
        file << "ifstream csv_file(KOPIC_CSV)" << endl;
        return false;
    }

    for(int line = 1; line <= SETTING_LINE; line += 1 ) {
        if( csv_file.getline(buffer, BUFFER_SIZE) ) {
            delete p;
            p = new string(buffer);
            s = *p + COMMA;

            q = s.find(COMMA);
            head = s.substr(0, q);
            q += COMMA_SIZE;
            tail = s.substr(q);

            q = tail.find(COMMA);
            body = tail.substr(0, q);

            switch(line) {
            case FROM_LINE:
                from = (int)strtol( body.c_str(), &stop, 10);
                break;
            case LOG_LINE:
                kopicLogText = body;
                break;
            case REPEAT_LINE:
                repeat = (int)strtol( body.c_str(), &stop, 10);
                break;
            case SETTING_LINE:
                setting = (int)strtol( body.c_str(), &stop, 10);
                break;
            default:
                weight[line] = strtod( body.c_str(), &stop);
                sum += weight[line];
                break;
            }

        } else {
            ofstream file(ERROR_TEXT);
            file << "csv_file.getline(buffer, BUFFER_SIZE): line = " << line << endl;
            return false;
        }

    }

    if(sum < EPSILON) {
        ofstream file(ERROR_TEXT);
        file << "sum < EPSILON" << endl;
        return false;
    }

    count = repeat - from;
    range = sum/4294967296.0;
    return true;
}

bool readRannuText(long *table_size) {
    using namespace std;

    char *b;
    char buffer[BUFFER_SIZE];
    char c0, c1;
    const char COMPLEMENTARY_ONE = '1';
    const char GAP = ' ';
    int k = 0;

// Using RANDOM_NUMBER_TEXT as binary
    ifstream test(RANDOM_NUMBER_TEXT, ios::binary);
    if( test.fail() ) {
        ofstream file(ERROR_TEXT);
        file << "ifstream test(RANDOM_NUMBER_TEXT, ios::binary)" << endl;
        return false;
    }

    test.seekg(0, ios::end);
    streampos length = test.tellg();
    int file_size = (int)length;
    test.close();

// random-number table
    random_number = new char[ file_size/3 ];

// Reopening RANDOM_NUMBER_TEXT
    ifstream file(RANDOM_NUMBER_TEXT);
    while( file.getline(buffer, BUFFER_SIZE) ) {
        for(b = &buffer[0]; *b != '\0'; ++b) {
            c0 = *b;
            if(c0 == GAP) {
                continue;
            }

            ++b;
            if(*b != '\0') {
                c1 = *b;
                if(c1 == GAP) {
                    c1 = COMPLEMENTARY_ONE;
                }

                random_number[k++] = two_digit_number[c0][c1];
            } else {
                break;
            }

        }

    }

    *table_size = k;
    return true;
}

bool Pickable::wideRange() {
    using namespace std;

// Buffering and grouping so that numbers can range from 0 to 4294967295.
    bool boundary = false;
    const unsigned int MASK = B00000000000000000000000000000001;
    int boolStream[BOOL_STREAM_SIZE];
    unsigned int bits, u;
    unsigned int shift[32] = {
        B00000000000000000000000000000001,
        B00000000000000000000000000000010,
        B00000000000000000000000000000100,
        B00000000000000000000000000001000,
        B00000000000000000000000000010000,
        B00000000000000000000000000100000,
        B00000000000000000000000001000000,
        B00000000000000000000000010000000,
        B00000000000000000000000100000000,
        B00000000000000000000001000000000,
        B00000000000000000000010000000000,
        B00000000000000000000100000000000,
        B00000000000000000001000000000000,
        B00000000000000000010000000000000,
        B00000000000000000100000000000000,
        B00000000000000001000000000000000,
        B00000000000000010000000000000000,
        B00000000000000100000000000000000,
        B00000000000001000000000000000000,
        B00000000000010000000000000000000,
        B00000000000100000000000000000000,
        B00000000001000000000000000000000,
        B00000000010000000000000000000000,
        B00000000100000000000000000000000,
        B00000001000000000000000000000000,
        B00000010000000000000000000000000,
        B00000100000000000000000000000000,
        B00001000000000000000000000000000,
        B00010000000000000000000000000000,
        B00100000000000000000000000000000,
        B01000000000000000000000000000000,
        0
    };

    shift[31] = (unsigned int)B10000000000000000000000000000000;

    int k = 0;
    ofstream error_file(BOUNDARY_TEXT);
    for(int m = 0; m < GROUP_SIZE; ) {
// Buffering
        u = random_number[r++];
        if(r >= table_size) {
            boundary = true;
            error_file << "r >= table_size" << endl;
            r = from;
        }

        for(int i = 0; i < GROUP_SIZE; ++i) {
            boolStream[k++] = MASK & u;
            u >>= 1;
        }

        if(k < BOOL_STREAM_SIZE) {
            continue;
        }

// Grouping
        for(k = 0; k < BOOL_STREAM_SIZE; ) {
            bits = 0;
            for(int i = 0; i < 32; ++i) {
                if(boolStream[k++]) {
                    bits |= shift[i];
                }

            }

            grouped[m++] = bits;
        }

        k = 0;
    }

    return boundary;
}

bool readCsv(const char *file_name, KUN_CODE *kc) {
    using namespace std;

    bool fromLine = false;
    bool logLine = false;
    bool repeatLine = false;
    bool settingLine = false;
    char buffer[BUFFER_SIZE];
    const int COUNT = KOPIC_REPEAT - KOPIC_FROM;
    const string COMMA(",");
    const string COMMA_SHARP(",#");
    const string DOT(".");
    const string EMPTY("");
    const string KO_LOG(KOPIC_LOG_TEXT);
    int ball;
    string *p = new string("");
    string head, head_comma, s, tail;
    string kopicFrom(KOPIC_FROM_SEQUENCE);
    string kopicRepeat(KOPIC_REPEAT_SEQUENCE);
    string kopicSetting(KOPIC_SETTING_SEQUENCE);
    string settingList[ SETTING_LINE + 1 ];
    unsigned int q;

// Setting the D array which includes ball numbers and commas ("37," for example)
    d[1] = B01; d[2] = B02; d[3] = B03; d[4] = B04; d[5] = B05; d[6] = B06; d[7] = B07; d[8] = B08; d[9] = B09; d[10] = B10; 
    d[11] = B11; d[12] = B12; d[13] = B13; d[14] = B14; d[15] = B15; d[16] = B16; d[17] = B17; d[18] = B18; d[19] = B19; d[20] = B20; 
    d[21] = B21; d[22] = B22; d[23] = B23; d[24] = B24; d[25] = B25; d[26] = B26; d[27] = B27; d[28] = B28; d[29] = B29; d[30] = B30; 
    d[31] = B31; d[32] = B32; d[33] = B33; d[34] = B34; d[35] = B35; d[36] = B36; d[37] = B37; d[38] = B38; d[39] = B39; d[40] = B40; 
    d[41] = B41; 

    settingList[0] = EMPTY;
    for(int i = 1; i <= SETTING_LINE; ++i) {
        settingList[i] = setWeightToZero(d[i], i);
    }

// Reading a CSV file to produce KOPIC_CSV
    ifstream csv_file(file_name);
    if( csv_file.fail() ) {
        ofstream file(ERROR_TEXT);
        file << file_name << endl;
        return false;
    }

    while( csv_file.getline(buffer, BUFFER_SIZE) ) {
        delete p;
        p = new string(buffer);

        q = p->find(COMMA_SHARP);
        if(q != string::npos) {
            s = p->substr(0, q);
        } else {
            s = *p;
        }

        q = s.find(COMMA);
        if(q != string::npos) {
            head = s.substr(0, q);
            q += COMMA_SIZE;
            tail = s.substr(q);

            s = trimmed(head);
            head_comma = headComma(s, &ball);
            if( head_comma.length() == 0 ) { // error
                continue;
            }

            tail = trimmed(tail);
            switch(ball) {
            case FROM_LINE:
                fromLine = true;
                kopicFrom = tail;
                settingList[ball] = head_comma + tail;
                break;
            case LOG_LINE:
                logLine = true;
                q = tail.find(DOT);
                if(q != string::npos) {
                    settingList[ball] = head_comma + tail;
                } else {
                    settingList[ball] = head_comma + KO_LOG;
                }

                break;
            case REPEAT_LINE:
                repeatLine = true;
                kopicRepeat = tail;
                settingList[ball] = head_comma + tail;
                break;
            case SETTING_LINE:
                settingLine = true;
                settingList[ball] = head_comma + tail;
                break;
            default:
                settingList[ball] = head_comma + tail;
                break;
            }

        }

    }

    if(! logLine) {
        settingList[LOG_LINE] = B39 + KO_LOG;
    }

    if(! settingLine) {
        settingList[SETTING_LINE] = B41 + kopicSetting;
    }

    if(! repeatLine) {
        settingList[REPEAT_LINE] = B40 + kopicRepeat;

        stringstream os;
        os << B38;
        if(kc->outputLines > 0) {
            const int OUTPUT_FROM = KOPIC_REPEAT - kc->outputLines;
            os << OUTPUT_FROM;
        } else {
            os << KOPIC_FROM;
        }

        string s38 = os.str();
        settingList[FROM_LINE] = s38;
        fromLine = true;
    }

    if(! fromLine) {
        stringstream ss(kopicRepeat);
        int repeat;
        ss >> repeat;

        stringstream os;
        os << B38;
        if(kc->outputLines > 0) {
            const int OUTPUT_FROM = repeat - kc->outputLines;
            os << OUTPUT_FROM;
        } else {
            int from = repeat - COUNT;
            os << from;
        }

        string s38 = os.str();
        settingList[FROM_LINE] = s38;
    }

// Checking if settingList[FROM_LINE] is acceptable.
    s = settingList[FROM_LINE];
    q = s.find(COMMA);
    if(q != string::npos) {
        q += COMMA_SIZE;
        tail = s.substr(q);
        stringstream ss(tail);
        int from;
        ss >> from;

        int repeat = KOPIC_REPEAT;
        s = settingList[REPEAT_LINE];
        q = s.find(COMMA);
        if(q != string::npos) {
            q += COMMA_SIZE;
            tail = s.substr(q);
            stringstream sm(tail);
            sm >> repeat;
        }

        if(from < 0) { // unacceptable
            from = KOPIC_FROM;

            if(kc->outputLines > 0) {
                repeat = from + kc->outputLines;
            } else {
                repeat = from + COUNT;
            }

        }

        stringstream os;
        os << B38 << from;
        string s38 = os.str();
        settingList[FROM_LINE] = s38;

        stringstream om;
        om << B40 << repeat;
        string s40 = om.str();
        settingList[REPEAT_LINE] = s40;
    }

    csv_file.close();
    ofstream file(KOPIC_CSV);
    for(int k = 1; k <= SETTING_LINE; ++k) {
        file << settingList[k] << endl;
    }

    untouched = modified_file(KOPIC_CSV);
    return true;
}

PICK_CODE kopicLog(const char *f, KUN_CODE *p) {
    using namespace std;

    bool check[100]; // 0 to 99
    bool csv = mm->csv;
    bool grouping = mm->grouping;
    bool produce_rannu_text = mm->produce_rannu_text;
    bool rannu_text_required, wide_range;
    int b;
    int interval_0 = mm->interval_0;
    int interval_1 = mm->interval_1;
    int lineCount = mm->lineCount;
    int prng = mm->prng;
    long kilo = mm->kilo;
    long table_size = 1L;
    PICK_CODE pc;
    RandomNumber *rn;

    strcpy(pc.file_name, f);

    if(p->defectiveCsv) {
// Reading a CSV file to produce KOPIC_CSV
        if(! readCsv(pc.file_name, p) ) {
            pc.code = NO_CSV;
            return pc;
        }

    }

    if(p->full_swing) {
// Rewriting KOPIC_CSV and creating KOPIC_TEXT
        fullSwing(KOPIC_CSV);
    }

// Reading KOPIC_CSV
    Pickable *k;
    if(p->weight) {
        if(p->mapping) {
            k = new Mapping();
            rannu_text_required = true;
            wide_range = false;
        } else {
            if(p->grouping) {
                k = new Tint();
                rannu_text_required = true;
                wide_range = true;
            } else {
                k = new Weight();
                rannu_text_required = false;
                wide_range = false;
            }

        }

    } else {
        k = new Transparent();
        rannu_text_required = true;
        wide_range = false;
    }

    if(! k->readKopicCsv() ) {
        pc.code = DEFECTIVE_CSV;
        return pc;
    }

    int count = k->comboCount();
    int from = k->idling();
    long seed = (long)k->seedData();
    if(seed == 0L) {
        long e = (long)time(NULL);
        seed = e & SEED_MASK;
        rn = new RandomNumber(kilo, seed, from, interval_0, interval_1, lineCount, prng, csv, grouping, produce_rannu_text);
        rn->setPRNG();

        int q = (int) rn->random_integer();
        int repeat = k->repetition();
        from += q%repeat;
    } else {
        rn = new RandomNumber(kilo, seed, from, interval_0, interval_1, lineCount, prng, csv, grouping, produce_rannu_text);
        rn->setPRNG();
    }

    mm->seed = seed;
    if(rannu_text_required) {
        ifstream test(RANDOM_NUMBER_TEXT);
        if( test.fail() ) {
            rn = new RandomNumber(kilo, seed, from, interval_0, interval_1, lineCount, prng, csv, p->grouping, produce_rannu_text);
            rn->createRannuText(mm->pathName);
        } else {
            test.close();
        }

// Reading RANDOM_NUMBER_TEXT to produce a random-number array
        setTwoDigitNumbers(); // two_digit_number[][]
        readRannuText(&table_size); // random_number[u]
        k->randomNumberArray(table_size, from);
        if(wide_range) {
            k->wideRange();
        }

    } else {
// Because the function internally produces random numbers, an external random-number table is unnecessary.
        k->internallyProduce(rn); // Weight::function( )

        random_number = new char[MAIN_BUFFER_SIZE];
        memset(random_number, 0, MAIN_BUFFER_SIZE);
        table_size = (long)MAIN_BUFFER_SIZE;
    }

// log file
    const int MERSENNE_TWISTER = 1;
    const int XORSHIFT = 6;
    string logFile = k->logFileName();
    ofstream file( logFile.c_str(), ios::app);
    if( file.fail() ) {
        ofstream file(ERROR_TEXT);
        file << "ofstream file( logFile.c_str(), ios::app)" << endl;
        pc.code = NO_LOG;
        return pc;
    }

    struct tm *time_block;
    time_t timer;
    timer = time(NULL);
    time_block = localtime(&timer);
    int y = 1900 + time_block->tm_year;
    int mm = 1 + time_block->tm_mon;
    int dd = time_block->tm_mday;
    int h = time_block->tm_hour;
    int m = time_block->tm_min;
    int sec = time_block->tm_sec;

    file << y << "-";
    file << fixedWidth(mm, '0', 2);
    file << "-";
    file << fixedWidth(dd, '0', 2);
    file << " ";
    file << fixedWidth(h, '0', 2);
    file << ":";
    file << fixedWidth(m, '0', 2);
    file << ":";
    file << fixedWidth(sec, '0', 2);

    string lines;
    if(count == 1) {
        const string ONE_LINE(" line...");
        lines = ONE_LINE;
    } else {
        const string TWO_OR_MORE_LINES(" lines...");
        lines = TWO_OR_MORE_LINES;
    }

    switch(prng) {
    case MERSENNE_TWISTER:
        file << FIRST_SIGNAL_MT << count << lines << endl;
        break;
    case XORSHIFT:
        file << FIRST_SIGNAL_XORSHIFT << count << lines << endl;
        break;
    }

    check[0] = false;
    for(int q = 1; q <= ALL; ++q) {
        check[q] = false;
    }

    const bool SERIAL_NUMBER = true;
    TimeName pt(PIC, TEXT_FILE);
    string timeNameText = pt.temporaryName(SERIAL_NUMBER);
    ofstream pick_text( timeNameText.c_str() );
    if( pick_text.fail() ) {
        ofstream file(ERROR_TEXT);
        file << "ofstream pick_text( timeNameText.c_str() )" << endl;
        pc.code = NO_TIME;
        return pc;
    } else {
        strcpy(pc.temporary_file_name, timeNameText.c_str() );
    }

    ofstream error_file(BOUNDARY_TEXT);
    int u = from;
    for(int j = 0; j < count; ++j) {
        for(int c = 0; c < LOTO; ++c) {
            do {
                b = k->function(random_number[u++]);
                if(u >= table_size) {
                    error_file << "u >= table_size" << endl;
                    u = from;
                }

            } while(check[b]);

            check[b] = true;
        }

        for(int r = 1; r <= ALL; ++r) {
            if(check[r]) {
                file << k->ball(r);
                pick_text << k->ball(r);
                check[r] = false;
            }

        }

        file << endl;
        pick_text << endl;
    }

    delete k;
    delete random_number;
    delete rn;
    pc.code = PICKED;
    return pc;
}

int secondField(char *p, std::string *file) {
    using namespace std;

    const int DOT_FOUND = 0;
    const string COMMA(",");
    const string DOT(".");
    string s(p);
    string second_field;
    unsigned int q;
    q = s.find(COMMA);
    if(q != string::npos) {
        q += COMMA_SIZE;
        second_field = s.substr(q);
    }

    q = second_field.find(DOT);
    if(q != string::npos) {
        *file = second_field;
        return DOT_FOUND;
    }

    stringstream ss(second_field);
    int value;
    ss >> value;
    return value;
}

int Mapping::function(int q) {
    if(q < 1) {
        q = 0;
    } else if(ALL < q) {
        q = q%ALL + 1;
    }

    return many_one[q];
}

int Tint::function(int dummy) {
    if(GROUP_SIZE <= g) {
        wideRange();
        g = 0;
    }

    double e_sum = range * (double)grouped[g++];
    double level = 0.0;

    for(int i = 1; i <= ALL; ++i) {
        level += weight[i];
        if(level >= e_sum) {
            return i;
        }

    }

    return NOT_FOUND;
}

int Transparent::function(int q) {
    return q;
}

int Weight::function(int dummy) {
    unsigned int q = rn->random_integer();
    double e_sum = range * (double)q;
    double level = 0.0;

    for(int i = 1; i <= ALL; ++i) {
        level += weight[i];
        if(level >= e_sum) {
            return i;
        }

    }

    return NOT_FOUND;
}

Mapping::Mapping() {
    using namespace std;

    variables();

    char *p;
    char *stop;
    char c[SMALL_BUFFER_SIZE];
    ifstream file(MANY_ONE_TEXT);
    if( file.fail() ) {
        ofstream error_text(ERROR_TEXT);
        error_text << MANY_ONE_TEXT << endl;
        return;
    }

    for(int line = 1; line <= ALL; line += 1 ) {
        if( file.getline(c, SMALL_BUFFER_SIZE) ) {
            p = strstr(c, PARTITION);
            if(p == NULL) {
                ofstream error_text(ERROR_TEXT);
                error_text << "strstr(c, PARTITION): p = NULL" << endl;
            } else {
                p += PARTITION_SIZE;
                many_one[line] = (int)strtol(p, &stop, 10);
            }

        } else {
            ofstream error_text(ERROR_TEXT);
            error_text << "ifstream file(MANY_ONE_TEXT): line = " << line << endl;
            return;
        }

    }

}

std::string fixedWidth(int n, int padding, int width) {
    using namespace std;

    char *p = new char[ width + 1 ];
    memset(p, padding, width);
    p[width] = '\0';

    stringstream os;
    os << n;
    string s = os.str();
    int number_length = s.length();
    char *q = & p[ width - number_length ];
    memcpy(q, s.c_str(), number_length);
    string fixed_width_number(p);
    delete p;
    return fixed_width_number;
}

std::string Mapping::ball(int q) {
    if(q < 1) {
        q = 0;
    } else if(ALL < q) {
        q = q%ALL + 1;
    }

    return b[q];
}

std::string Tint::ball(int q) {
    if(q < 1) {
        q = 0;
    } else if(ALL < q) {
        q = q%ALL + 1;
    }

    return b[q];
}

std::string Transparent::ball(int q) {
    return b[q];
}

std::string Weight::ball(int q) {
    if(q < 1) {
        q = 0;
    } else if(ALL < q) {
        q = q%ALL + 1;
    }

    return b[q];
}

std::string headComma(std::string & h, int *p) {
    using namespace std;

    bool ball_label = true;
    const string B01("01,");
    const string B02("02,");
    const string B03("03,");
    const string B04("04,");
    const string B05("05,");
    const string B06("06,");
    const string B07("07,");
    const string B08("08,");
    const string B09("09,");
    const string COMMA(",");
    const string EMPTY("");
    const string FROM_COMMA("From,");
    const string LOG_COMMA("Log,");
    const string REPEAT_COMMA("Repeat,");
    const string SETTING_COMMA("Setting,");
    unsigned int q;
    string head = h;
    string head_comma = EMPTY;
    string ball_comma[10];
    ball_comma[0] = EMPTY; ball_comma[1] = B01; ball_comma[2] = B02; ball_comma[3] = B03; ball_comma[4] = B04; ball_comma[5] = B05; ball_comma[6] = B06; ball_comma[7] = B07; ball_comma[8] = B08; ball_comma[9] = B09;
    q = FROM_COMMA.find(head);
    if(q != string::npos) {
        head_comma = FROM_COMMA;
        *p = FROM_LINE;
        ball_label = false;
    }

    q = LOG_COMMA.find(head);
    if(q != string::npos) {
        head_comma = LOG_COMMA;
        *p = LOG_LINE;
        ball_label = false;
    }

    q = REPEAT_COMMA.find(head);
    if(q != string::npos) {
        head_comma = REPEAT_COMMA;
        *p = REPEAT_LINE;
        ball_label = false;
    }

    q = SETTING_COMMA.find(head);
    if(q != string::npos) {
        head_comma = SETTING_COMMA;
        *p = SETTING_LINE;
        ball_label = false;
    }

    if(ball_label) {
        stringstream ss(head);
        int ball;
        ss >> ball;
        if(1 <= ball && ball < 10) {
            head_comma = ball_comma[ball]; // "01,"
        } else if(10 <= ball && ball <= ALL) {
            head_comma = head + COMMA; // "31,"
        } else {
            head_comma = EMPTY; // error
        }

        *p = ball;
    }

    return head_comma;
}

std::string setWeightToZero(std::string & d, int ball) {
    using namespace std;

    const string EMPTY("");
    const string ZERO("0");
    string item;
    stringstream os;

    switch(ball) {
    case FROM_LINE:
        os << d << KOPIC_FROM;
        item = os.str();
        break;
    case LOG_LINE:
        os << d << KOPIC_LOG_TEXT;
        item = os.str();
        break;
    case REPEAT_LINE:
        os << d << KOPIC_REPEAT;
        item = os.str();
        break;
    case SETTING_LINE:
        os << d << KOPIC_SETTING;
        item = os.str();
        break;
    default:
        if(1 <= ball && ball < FROM_LINE) {
            os << d << ZERO;
            item = os.str();
        } else {
            item = EMPTY;
        }

        break;
    }

    return item;
}

std::string trimmed(std::string & a) {
    int length = a.length();
    char *p = new char[ length + 1 ];

    strcpy(p, a.c_str() );
    int leftmost_end_space = strspn(p, " ");
    int rightmost_end_space = strspn( strrev(p), " ");
    int body = length - leftmost_end_space - rightmost_end_space;

    delete p;
    return a.substr(leftmost_end_space, body);
}

void Pickable::variables() {
    using namespace std;

    g = 0;
    r = 0;
    sum = 0.0;
    weight[0] = 0.0;

    string B00("00 "); string B01("01 "); string B02("02 "); string B03("03 "); string B04("04 "); string B05("05 "); string B06("06 "); string B07("07 "); string B08("08 "); string B09("09 "); 
    string B10("10 "); string B11("11 "); string B12("12 "); string B13("13 "); string B14("14 "); string B15("15 "); string B16("16 "); string B17("17 "); string B18("18 "); string B19("19 "); 
    string B20("20 "); string B21("21 "); string B22("22 "); string B23("23 "); string B24("24 "); string B25("25 "); string B26("26 "); string B27("27 "); string B28("28 "); string B29("29 "); 
    string B30("30 "); string B31("31 "); string B32("32 "); string B33("33 "); string B34("34 "); string B35("35 "); string B36("36 "); string B37("37 "); string B38("38 "); string B39("39 "); 
    string B40("40 "); string B41("41 "); string B42("42 "); string B43("43 "); string B44("44 "); string B45("45 "); string B46("46 "); string B47("47 "); string B48("48 "); string B49("49 "); 
    string B50("50 "); string B51("51 "); string B52("52 "); string B53("53 "); string B54("54 "); string B55("55 "); string B56("56 "); string B57("57 "); string B58("58 "); string B59("59 "); 
    string B60("60 "); string B61("61 "); string B62("62 "); string B63("63 "); string B64("64 "); string B65("65 "); string B66("66 "); string B67("67 "); string B68("68 "); string B69("69 "); 
    string B70("70 "); string B71("71 "); string B72("72 "); string B73("73 "); string B74("74 "); string B75("75 "); string B76("76 "); string B77("77 "); string B78("78 "); string B79("79 "); 
    string B80("80 "); string B81("81 "); string B82("82 "); string B83("83 "); string B84("84 "); string B85("85 "); string B86("86 "); string B87("87 "); string B88("88 "); string B89("89 "); 
    string B90("90 "); string B91("91 "); string B92("92 "); string B93("93 "); string B94("94 "); string B95("95 "); string B96("96 "); string B97("97 "); string B98("98 "); string B99("99 "); 

    b[0] = B00; b[1] = B01; b[2] = B02; b[3] = B03; b[4] = B04; b[5] = B05; b[6] = B06; b[7] = B07; b[8] = B08; b[9] = B09; 
    b[10] = B10; b[11] = B11; b[12] = B12; b[13] = B13; b[14] = B14; b[15] = B15; b[16] = B16; b[17] = B17; b[18] = B18; b[19] = B19; 
    b[20] = B20; b[21] = B21; b[22] = B22; b[23] = B23; b[24] = B24; b[25] = B25; b[26] = B26; b[27] = B27; b[28] = B28; b[29] = B29; 
    b[30] = B30; b[31] = B31; b[32] = B32; b[33] = B33; b[34] = B34; b[35] = B35; b[36] = B36; b[37] = B37; b[38] = B38; b[39] = B39; 
    b[40] = B40; b[41] = B41; b[42] = B42; b[43] = B43; b[44] = B44; b[45] = B45; b[46] = B46; b[47] = B47; b[48] = B48; b[49] = B49; 
    b[50] = B50; b[51] = B51; b[52] = B52; b[53] = B53; b[54] = B54; b[55] = B55; b[56] = B56; b[57] = B57; b[58] = B58; b[59] = B59; 
    b[60] = B60; b[61] = B61; b[62] = B62; b[63] = B63; b[64] = B64; b[65] = B65; b[66] = B66; b[67] = B67; b[68] = B68; b[69] = B69; 
    b[70] = B70; b[71] = B71; b[72] = B72; b[73] = B73; b[74] = B74; b[75] = B75; b[76] = B76; b[77] = B77; b[78] = B78; b[79] = B79; 
    b[80] = B80; b[81] = B81; b[82] = B82; b[83] = B83; b[84] = B84; b[85] = B85; b[86] = B86; b[87] = B87; b[88] = B88; b[89] = B89; 
    b[90] = B90; b[91] = B91; b[92] = B92; b[93] = B93; b[94] = B94; b[95] = B95; b[96] = B96; b[97] = B97; b[98] = B98; b[99] = B99; 
}

void setTwoDigitNumbers() {
    two_digit_number['0']['0'] = 0; two_digit_number['0']['1'] = 1; two_digit_number['0']['2'] = 2; two_digit_number['0']['3'] = 3; two_digit_number['0']['4'] = 4; two_digit_number['0']['5'] = 5; two_digit_number['0']['6'] = 6; two_digit_number['0']['7'] = 7; two_digit_number['0']['8'] = 8; two_digit_number['0']['9'] = 9; 
    two_digit_number['1']['0'] = 10; two_digit_number['1']['1'] = 11; two_digit_number['1']['2'] = 12; two_digit_number['1']['3'] = 13; two_digit_number['1']['4'] = 14; two_digit_number['1']['5'] = 15; two_digit_number['1']['6'] = 16; two_digit_number['1']['7'] = 17; two_digit_number['1']['8'] = 18; two_digit_number['1']['9'] = 19; 
    two_digit_number['2']['0'] = 20; two_digit_number['2']['1'] = 21; two_digit_number['2']['2'] = 22; two_digit_number['2']['3'] = 23; two_digit_number['2']['4'] = 24; two_digit_number['2']['5'] = 25; two_digit_number['2']['6'] = 26; two_digit_number['2']['7'] = 27; two_digit_number['2']['8'] = 28; two_digit_number['2']['9'] = 29; 
    two_digit_number['3']['0'] = 30; two_digit_number['3']['1'] = 31; two_digit_number['3']['2'] = 32; two_digit_number['3']['3'] = 33; two_digit_number['3']['4'] = 34; two_digit_number['3']['5'] = 35; two_digit_number['3']['6'] = 36; two_digit_number['3']['7'] = 37; two_digit_number['3']['8'] = 38; two_digit_number['3']['9'] = 39; 
    two_digit_number['4']['0'] = 40; two_digit_number['4']['1'] = 41; two_digit_number['4']['2'] = 42; two_digit_number['4']['3'] = 43; two_digit_number['4']['4'] = 44; two_digit_number['4']['5'] = 45; two_digit_number['4']['6'] = 46; two_digit_number['4']['7'] = 47; two_digit_number['4']['8'] = 48; two_digit_number['4']['9'] = 49; 
    two_digit_number['5']['0'] = 50; two_digit_number['5']['1'] = 51; two_digit_number['5']['2'] = 52; two_digit_number['5']['3'] = 53; two_digit_number['5']['4'] = 54; two_digit_number['5']['5'] = 55; two_digit_number['5']['6'] = 56; two_digit_number['5']['7'] = 57; two_digit_number['5']['8'] = 58; two_digit_number['5']['9'] = 59; 
    two_digit_number['6']['0'] = 60; two_digit_number['6']['1'] = 61; two_digit_number['6']['2'] = 62; two_digit_number['6']['3'] = 63; two_digit_number['6']['4'] = 64; two_digit_number['6']['5'] = 65; two_digit_number['6']['6'] = 66; two_digit_number['6']['7'] = 67; two_digit_number['6']['8'] = 68; two_digit_number['6']['9'] = 69; 
    two_digit_number['7']['0'] = 70; two_digit_number['7']['1'] = 71; two_digit_number['7']['2'] = 72; two_digit_number['7']['3'] = 73; two_digit_number['7']['4'] = 74; two_digit_number['7']['5'] = 75; two_digit_number['7']['6'] = 76; two_digit_number['7']['7'] = 77; two_digit_number['7']['8'] = 78; two_digit_number['7']['9'] = 79; 
    two_digit_number['8']['0'] = 80; two_digit_number['8']['1'] = 81; two_digit_number['8']['2'] = 82; two_digit_number['8']['3'] = 83; two_digit_number['8']['4'] = 84; two_digit_number['8']['5'] = 85; two_digit_number['8']['6'] = 86; two_digit_number['8']['7'] = 87; two_digit_number['8']['8'] = 88; two_digit_number['8']['9'] = 89; 
    two_digit_number['9']['0'] = 90; two_digit_number['9']['1'] = 91; two_digit_number['9']['2'] = 92; two_digit_number['9']['3'] = 93; two_digit_number['9']['4'] = 94; two_digit_number['9']['5'] = 95; two_digit_number['9']['6'] = 96; two_digit_number['9']['7'] = 97; two_digit_number['9']['8'] = 98; two_digit_number['9']['9'] = 99; 
}

