/*
Zoko VCL Version 1.11
Finding Loto-7 winners
Copyright 2017 Sogaya

C++Builder 5

*/

#include <vcl.h>
#include "zoko.h"
#pragma hdrstop
USERES("zoko.res");
USEFORM("zokoMain.cpp", Form1);
USEFORM("C:\BORLAND\CBUILDER5\OBJREPOS\OKCANCL2.cpp", OKRightDlg);
USEFORM("zokoVersion.cpp", OKHelpRightDlg);
USEUNIT("OS-specific.cpp");
USEFORM("zokoWeight.cpp", OKRightDlg1);
USEUNIT("kopicLog.cpp");
USEUNIT("Split.cpp");
USEUNIT("MT.cpp");
USEUNIT("mt19937ar.cpp");
USEUNIT("Numbered.cpp");
USEUNIT("Xorshift.cpp");
USEUNIT("TimeName.cpp");
USEUNIT("kun.cpp");
USEUNIT("rannuText.cpp");
USEUNIT("OutputNewLine.cpp");
USEFORM("zokoCSV.cpp", OKBottomDlg);
USEUNIT("DateFollowed.cpp");
USEUNIT("Dividing.cpp");
USEUNIT("lotoLine.cpp");
USEUNIT("TableCsv.cpp");
USEUNIT("Combo.cpp");
USEUNIT("NewLines.cpp");
USEUNIT("Drafo.cpp");
USEUNIT("EditCount.cpp");
USEUNIT("Exclude.cpp");
USEUNIT("ToSeven.cpp");
USEUNIT("ZokoBonus.cpp");
USEUNIT("ZokoMask.cpp");
USEUNIT("FormDateLine.cpp");
USEUNIT("Optional.cpp");

char CSVname[FILE_NAME_SIZE];
double version = VERSION;
extern char *random_number;
extern MANAGE_MEMO *mm;
KUN_CODE *kunCode;

namespace {
    using namespace std;

    const bool WITH_COMMENTS = true;
    const bool WITHOUT_COMMENTS = false;
    const int BALLS = 4;
    const int ERROR_CODE = 1;
    const int MERSENNE_TWISTER = 1;
    const int XORSHIFT = 6;
    const string CLOSE_BRACKET(" )");
    const string DRAFO_CSV("drafo.csv");
    const string EMPTY("");
    const string EXCLUDE_TEXT("exclude.txt");
    const string ZERO("0");
    const string DIAGONAL("-d");
    const string EXCLUDE("-e");
    const string NO_EDITING("-e-");
    const string NO_PREEDITING("-p-");
    const string NO_REMOVING("-r-");
    const string NO_SPLITTING("-s-");
    const string OVERWRITE("-o");
    const string PRNG_MT("-pm");
    const string PRNG_XORSHIFT("-px");
    const string QUIT("-q");
    const string REMOVE_LINE_1("-1-");
    const string SEED_TERM("-s");
    const string SEPARATE_TEXT("separate.txt");
    const string THREE_LINES_UNITED("-3");
    const string VERSION_COMMENTS("-VC");
    const string VERSION_GUIDE("-V");
    const string WHERE("-w");

    const string m0(           ""); // m[0], FULL_PATH_NAME includes MANAGE_TEXT.
    const string m1(    "who.txt"); // m[1], fileName
    const string m2("exclude.txt"); // m[2], list_of_items
    const string m3(          "4"); // m[3], balls
    const string m4(          "0"); // m[4], editor
    const string m5(          "1"); // m[5], firstLine
    const string m6(          "0"); // m[6], noSplitting
    const string m7(          "1"); // m[7], preedit
    const string m8(       "5000"); // m[8], rowCount
    const string m9(          "1"); // m[9], serialNumber
    const string m10(         "0"); // m[10], mark
    const string m11(         "0"); // m[11], whoText
    const string m12(         "0"); // m[12], threeLinesUnited
    const string m13(         "0"); // m[13], whichCorner
    const string m14(        "20"); // m[14], left of CSV
    const string m15(        "20"); // m[15], top of CSV
    const string m16(       "800"); // m[16], width of CSV
    const string m17(       "600"); // m[17], height of CSV
    const string m18(         "1"); // m[18], check box of CSV

    bool csv, editor, firstLine, mark, noSplitting, preedit, serialNumber, threeLinesUnited, whoText;
    int balls, rowCount, whichCorner;
    std::string error, fileName, FULL_PATH_NAME, list_of_items, textName;
    std::string m[ MANAGE_TEXT_LINE_COUNT + 1 ];
}

bool readFilesBeforeCreatingWindows(std::string & commandLine) {
    using namespace std;

    bool checkBox = true;
    bool countBonus = false;
    bool destroyWhoText = false;
    bool provided[PROVIDED_SIZE];
    bool quit = false;
    bool remove_first = true;
    int prng = MERSENNE_TWISTER;
    int q;
    int csv_x = 20;
    int csv_y = 20;
    int csv_w = 800;
    int csv_h = 600;
    long seed = 0L;
    Numbered *n = new Numbered("");
    string *p = new string("");
    string argument;
    string who_text("who.txt");
    string c_zokoVCL_manage_text("C:\\zokoVCL\\manage.txt");
    string c_zokoVCL_rannu_text("C:\\zokoVCL\\rannu.txt");
    string c_zokoVCL_who_csv("C:\\zokoVCL\\who7654-32-10.csv");
    string manage_text_name(MANAGE_TEXT);
    string m[ MANAGE_TEXT_LINE_COUNT + 1 ];
    string preedited;
    string whoTextLine1 = EMPTY;

    balls = BALLS;
    csv = false;
    editor = false;
    fileName = who_text;
    firstLine = true;
    FULL_PATH_NAME = c_zokoVCL_manage_text;
    list_of_items = EXCLUDE_TEXT;
    m[0] = m0; m[1] = m1; m[2] = m2; m[3] = m3; m[4] = m4; m[5] = m5; m[6] = m6; m[7] = m7; m[8] = m8; m[9] = m9; m[10] = m10; m[11] = m11; m[12] = m12; m[13] = m13; m[14] = m14; m[15] = m15; m[16] = m16; m[17] = m17; m[18] = m18;
    mark = false;
    mm->csv = false;
    mm->onlyTwo = false;
    mm->showWhere = false;
    noSplitting = false;
    preedit = true;
    preedited = who_text;
    rowCount = CSV_LINE_COUNT;
    serialNumber = true;
    textName = c_zokoVCL_who_csv;
    threeLinesUnited = false;
    whoText = true; // destroyWhoText = false;

    provided[0] = testDrafoCsv();
    provided[1] = testExcludeText();
    provided[2] = testKopicCsv();
    provided[3] = testSeparateText();
    for(int i = 0; i < PROVIDED_SIZE; ++i) {
        if(provided[i]) {
            continue;
        } else {
            return ERROR_CODE;
        }

    }

// C:\zokoVCL\manage.txt for example
    string firstPart = currentDirectory(); // OS-specific.h and OS-specific.cpp
    NAMES a = driveDirectoryBase(firstPart);
    string SEPARATOR = a.separator;
    string root = a.name[1];
    if (firstPart == root) { // C:\ for example
        FULL_PATH_NAME = root + manage_text_name;
    } else { // C:\zokoVCL for example
        FULL_PATH_NAME = firstPart + SEPARATOR + manage_text_name;
    }

    mm->FULL_PATH_NAME = FULL_PATH_NAME;

    ifstream file( FULL_PATH_NAME.c_str() );
    if ( file.fail() ) { // MANAGE_TEXT
// Creating MANAGE_TEXT
        ofstream manage_text( FULL_PATH_NAME.c_str() );
        for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1 ) {
            manage_text << m[line] << endl;
        }

        return false;
    } else {
        file.close();
    }

// Reading MANAGE_TEXT
    char c[BUFFER_SIZE];
    ifstream in( FULL_PATH_NAME.c_str() );
    m[0] = FULL_PATH_NAME;
    for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1 ) {
        if( in.getline(c, BUFFER_SIZE) ) {
            delete p;
            p = new string(c);
            m[line] = *p;
        } else {
            break;
        }

    }

    in.close();

    balls = integerFromString(m[3]);
    destroyWhoText = (ZERO == m[11]) ? false : true;
    editor = (ZERO == m[4]) ? false : true;
    fileName = m[1];
    firstLine = (ZERO == m[5]) ? false : true;
    list_of_items = m[2];
    mark = (ZERO == m[10]) ? false : true;
    noSplitting = (ZERO == m[6]) ? false : true;
    preedit = (ZERO == m[7]) ? false : true;
    rowCount = integerFromString(m[8]);
    serialNumber = (ZERO == m[9]) ? false : true;
    threeLinesUnited = (ZERO == m[12]) ? false : true;
    whichCorner = integerFromString(m[13]);
    const int based_on_m13 = whichCorner;

    csv_x = integerFromString(m[14]);
    csv_y = integerFromString(m[15]);
    csv_w = integerFromString(m[16]);
    csv_h = integerFromString(m[17]);
    checkBox = (ZERO == m[18]) ? false : true;

    char r[SMALL_BUFFER_SIZE];
    Dividing d(commandLine);
    const int FIELD_COUNT = d.fieldCount();
    for(int i = 1; i < FIELD_COUNT; ++i) {
        argument = d.a(i);
        if( argument.length() == 0 ) {
            break;
        }

        if(EXCLUDE == argument) {
            list_of_items = EXCLUDE_TEXT;
        } else if(NO_EDITING == argument) {
            preedit = false;
        } else if(NO_PREEDITING == argument) {
            preedit = false;
        } else if(NO_REMOVING == argument) {
            remove_first = false;
        } else if(NO_SPLITTING == argument) {
            noSplitting = true;
        } else if(OVERWRITE == argument) {
            destroyWhoText = true;
        } else if( PRNG_MT == argument ) {
            prng = MERSENNE_TWISTER;
        } else if( PRNG_XORSHIFT == argument ) {
            prng = XORSHIFT;
        } else if(QUIT == argument) {
            quit = true;
        } else if(REMOVE_LINE_1 == argument) {
            firstLine = false;
        } else if(argument == THREE_LINES_UNITED) { // The web browser may divide a date line into three lines, which shall be united to form the date line.
            threeLinesUnited = true;
        } else if(VERSION_GUIDE == argument) {
            guide(WITHOUT_COMMENTS);
            delete n; delete p;
            return false;
        } else if(VERSION_COMMENTS == argument) {
            guide(WITH_COMMENTS);
            delete n; delete p;
            return false;
        } else if(WHERE == argument) {
            mm->showWhere = true;
        } else {
            if(whoText) {
                fileName = argument;
                whoText = false;
            } else {
                q = argument.find(DIAGONAL);
                if(q != string::npos) {
                    delete n;
                    strcpy(r, argument.c_str() );
                    n = new Numbered(r);
                    whichCorner = n->number();
                    if( n->parameter() == DIAGONAL ) {
                        continue;
                    }

                    whichCorner = based_on_m13;
                }

                q = argument.find(SEED_TERM);
    			if(q != string::npos) {
                    delete n;
                    strcpy(r, argument.c_str() );
                    n = new Numbered(r);
                    seed = (long) n->number();
                    if( n->parameter() == SEED_TERM ) {
                        continue;
                    }

                    seed = 0L;
                }

                list_of_items = argument;
            }

        }

    }

    delete n;
    if(remove_first) {
        removeTemporaryFiles();
    }

    whoText = destroyWhoText;
    delete p;

    if(preedit) {
        EditCount *ec = new EditCount();
        ec->setting(FULL_PATH_NAME, fileName, list_of_items, balls, countBonus, csv, firstLine, noSplitting, preedit, quit, serialNumber, threeLinesUnited, whoText);
        if( ec->preediting() ) {
            preedited = ec->saved();
        } else {
            error = ec->inquiry();
            createErrorText(error);
            return false;
        }

        delete ec;
    }

// Software produces CSV before the Zoko window appears.
    TableCsv *tc = new TableCsv(rowCount, serialNumber, whoText);
    if( tc->run(preedited) ) { // mm->draw[i]
        textName = tc->saved();
        delete tc;
    } else {
        error = tc->inquiry();
        createErrorText(error);
        return 0;
    }

    mm->balls = balls;
    mm->checkBox = checkBox;
    mm->countBonus = countBonus;
    mm->csv = csv;
    mm->csv_h = csv_h;
    mm->csv_w = csv_w;
    mm->csv_x = csv_x;
    mm->csv_y = csv_y;
    mm->editor = editor;
    mm->fileName = fileName;
    mm->firstLine = firstLine;
    mm->FULL_PATH_NAME = FULL_PATH_NAME;
    mm->grouping = false;
    mm->interval_0 = 1;
    mm->interval_1 = 37;
    mm->kilo = KILOBYTES;
    mm->lineCount = LARGE_NUMBER;
    mm->list_of_items = list_of_items;
    mm->mark = mark;
    mm->noSplitting = noSplitting;
    mm->pathName = c_zokoVCL_rannu_text;
    mm->pleaseCheck = true;
    mm->preedit = preedit;
    mm->prng = prng;
    mm->produce_rannu_text = true;
    mm->rowCount = rowCount;
    mm->seed = seed;
    mm->serialNumber = serialNumber;
    mm->textName = textName;
    mm->threeLinesUnited = threeLinesUnited;
    mm->whichCorner = whichCorner;
    mm->whoCSV = true;
    mm->whoText = whoText;
    mm->whoTextLine1 = whoTextLine1;
    mm->zoko_h = MAIN_HEIGHT;
    mm->zoko_w = MAIN_WIDTH;
    mm->zoko_x = MAIN_X;
    mm->zoko_y = MAIN_Y;

    int result = quit ? false : true;
    return result;
}

bool removeTemporaryFiles() {
    using namespace std;

    bool match;
    char c[FILE_NAME_SIZE];
    ifstream in(REMOVE_ERROR_TEXT);
    if( in.fail() ) {
        return false;
    }

    while( in.getline(c, FILE_NAME_SIZE) ) {
        if( strcmp(c, SEE_TEXT) ) { // Do not remove SEE_TEXT.
            if( strcmp(c, TABULATE_TEXT) ) { // Do not remove TABULATE_TEXT.
                if( strcmp(c, TRUE_TEXT) ) { // Do not remove TRUE_TEXT.
                    if( strcmp(c, WHO_TEXT) ) { // Do not remove WHO_TEXT.
                        remove(c);
                    }

                }

            }

        }

    }

    return true;
}

bool testDrafoCsv() {
    using namespace std;

    bool result;
    ifstream test( DRAFO_CSV.c_str() );
    if( test.fail() ) {
        result = false;
    } else {
        test.close();
        result = true;
        return result;
    }

    ofstream file( DRAFO_CSV.c_str() );
    file << "&#160;, ," << endl;
    file << "&nbsp;, ," << endl;
    file << "a,A," << endl;
    file << "l,L," << endl;
    file << "p,P," << endl;
    file << "q,Q," << endl;
    file << "\\,, ," << endl;
    file << "., ," << endl;
    file << "      , ," << endl;
    file << "     , ," << endl;
    file << "    , ," << endl;
    file << "   , ," << endl;
    file << "  , ," << endl;
    file << " 1 , 01 ," << endl;
    file << " 2 , 02 ," << endl;
    file << " 3 , 03 ," << endl;
    file << " 4 , 04 ," << endl;
    file << " 5 , 05 ," << endl;
    file << " 6 , 06 ," << endl;
    file << " 7 , 07 ," << endl;
    file << " 8 , 08 ," << endl;
    file << " 9 , 09 ," << endl;
    file << "ALLQP,ALL QP," << endl;
    file << "|,/," << endl;
    return result;
}

bool testExcludeText() {
    using namespace std;

    bool result;
    ifstream test( EXCLUDE_TEXT.c_str() );
    if( test.fail() ) {
        result = false;
    } else {
        test.close();
        result = true;
        return result;
    }

    ofstream file( EXCLUDE_TEXT.c_str() );
    file << "ʂ" << endl; // Shift_JIS
    file << " ID:" << endl;
    return result;
}

bool testKopicCsv() {
    using namespace std;

    bool result;
    ifstream test(KOPIC_CSV);
    if( test.fail() ) {
        result = false;
    } else {
        test.close();
        result = true;
        return result;
    }

    ofstream file(KOPIC_CSV);
    file << "01,22" << endl;
    file << "02,23" << endl;
    file << "03,24" << endl;
    file << "04,25" << endl;
    file << "05,25" << endl;
    file << "06,26" << endl;
    file << "07,26" << endl;
    file << "08,26" << endl;
    file << "09,26" << endl;
    file << "10,26" << endl;
    file << "11,25" << endl;
    file << "12,25" << endl;
    file << "13,25" << endl;
    file << "14,24" << endl;
    file << "15,24" << endl;
    file << "16,23" << endl;
    file << "17,23" << endl;
    file << "18,22" << endl;
    file << "19,21" << endl;
    file << "20,21" << endl;
    file << "21,20" << endl;
    file << "22,19" << endl;
    file << "23,19" << endl;
    file << "24,18" << endl;
    file << "25,17" << endl;
    file << "26,17" << endl;
    file << "27,16" << endl;
    file << "28,16" << endl;
    file << "29,15" << endl;
    file << "30,15" << endl;
    file << "31,15" << endl;
    file << "32,15" << endl;
    file << "33,15" << endl;
    file << "34,14" << endl;
    file << "35,15" << endl;
    file << "36,16" << endl;
    file << "37,16" << endl;
    file << "From,400" << endl;
    file << "Log,KO.LOG" << endl;
    file << "Repeat,420" << endl;
    file << "Setting,0" << endl;
    return result;
}

bool testSeparateText() {
    using namespace std;

    bool result;
    ifstream test( SEPARATE_TEXT.c_str() );
    if( test.fail() ) {
        result = false;
    } else {
        test.close();
        result = true;
        return result;
    }

    ofstream file( SEPARATE_TEXT.c_str() );
    file << "/" << endl;
    file << "|" << endl;
    return result;
}

PICK_CODE settingBeforehand(const char *f, KUN_CODE *p) {
    using namespace std;

    const string RANNU_TXT(RANDOM_NUMBER_TEXT);
    const string YEN = "\\";
    string pathName = currentDirectory();
    pathName += YEN;
    pathName += RANNU_TXT;

    mm->csv = false;
    mm->grouping = p->grouping;
    mm->interval_0 = 1;
    mm->interval_1 = 37;
    mm->kilo = KILOBYTES;
    mm->lineCount = LARGE_NUMBER;
    mm->pathName = pathName;
    mm->prng = p->prng;
    mm->produce_rannu_text = true;

    bool check[100]; // 0 to 99
    bool csv = mm->csv;
    bool grouping = mm->grouping;
    bool produce_rannu_text = mm->produce_rannu_text;
    bool rannu_text_required, wide_range;
    int b;
    int interval_0 = mm->interval_0;
    int interval_1 = mm->interval_1;
    int lineCount = mm->lineCount;
    int prng = mm->prng;
    long kilo = mm->kilo;
    long table_size = 1L;
    PICK_CODE pc;
    RandomNumber *rn;

    strcpy(pc.file_name, f);

    if(p->defectiveCsv) {
// Reading a CSV file to produce KOPIC_CSV
        if(! readCsv(pc.file_name, p) ) {
            pc.code = NO_CSV;
            return pc;
        }

    }

    if(p->full_swing) {
// Rewriting KOPIC_CSV and creating KOPIC_TEXT
        fullSwing(KOPIC_CSV);
    }

// Reading KOPIC_CSV
    Pickable *k;
    if(p->weight) {
        if(p->mapping) {
            k = new Mapping();
            rannu_text_required = true;
            wide_range = false;
        } else {
            if(p->grouping) {
                k = new Tint();
                rannu_text_required = true;
                wide_range = true;
            } else {
                k = new Weight();
                rannu_text_required = false;
                wide_range = false;
            }

        }

    } else {
        k = new Transparent();
        rannu_text_required = true;
        wide_range = false;
    }

    if(! k->readKopicCsv() ) {
        pc.code = DEFECTIVE_CSV;
        return pc;
    }

    int count = k->comboCount();
    int from = k->idling();
    long seed = (long)k->seedData();
    if(seed == 0L) {
        long e = (long)time(NULL);
        seed = e & SEED_MASK;
        rn = new RandomNumber(kilo, seed, from, interval_0, interval_1, lineCount, prng, csv, grouping, produce_rannu_text);
        rn->setPRNG();

        int q = (int) rn->random_integer();
        int repeat = k->repetition();
        from += q%repeat;
    } else {
        rn = new RandomNumber(kilo, seed, from, interval_0, interval_1, lineCount, prng, csv, grouping, produce_rannu_text);
        rn->setPRNG();
    }

    mm->seed = seed;
    if(rannu_text_required) {
        ifstream test(RANDOM_NUMBER_TEXT);
        if( test.fail() ) {
            rn = new RandomNumber(kilo, seed, from, interval_0, interval_1, lineCount, prng, csv, p->grouping, produce_rannu_text);
            rn->createRannuText(mm->pathName);
        } else {
            test.close();
        }

// Reading RANDOM_NUMBER_TEXT to produce a random-number array
        setTwoDigitNumbers(); // two_digit_number[][]
        readRannuText(&table_size); // random_number[u]
        k->randomNumberArray(table_size, from);
        if(wide_range) {
            k->wideRange();
        }

    } else {
// Because the function internally produces random numbers, an external random-number table is unnecessary.
        k->internallyProduce(rn); // Weight::function( )

        random_number = new char[MAIN_BUFFER_SIZE];
        memset(random_number, 0, MAIN_BUFFER_SIZE);
        table_size = (long)MAIN_BUFFER_SIZE;
    }

    delete k;
    delete rn;
    pc.code = UNPICKED;
    return pc;
}

void guide(bool comments) {
    using namespace std;

    if(comments) {
        ofstream file(VERSION_TEXT);
        file << "zoko VCL Version " << VERSION << "\n" << endl
            << "zoko who.txt -3   # Unite three lines to form a date Line. " << endl 
            << "zoko who.txt -d3  # Move the Zoko window to Corner-3. " << endl
            << "zoko who.txt -e exclude.txt # Every nurupo resu is excluded from who.txt " << endl
            << "zoko who.txt -o   # Overwrite who.txt " << endl
            << "zoko who.txt -p-  # Do not edit who.txt " << endl
            << "zoko who.txt -q   # Quit before finding. " << endl
            << "zoko who.txt -r-  # Do not remove temporary files. " << endl
            << "zoko who.txt -s-  # Do not split date lines. " << endl
            << "zoko who.txt -w   # Show where the cursor is. " << endl
            << "zoko -V           # version " << endl
            << "zoko -VC          # version with comments " << endl;
    } else {
        ofstream file(VERSION_TEXT);
        file << "zoko VCL Version " << VERSION << "\n" << endl 
            << "zoko who.txt -3   " << endl 
            << "zoko who.txt -d3  " << endl 
            << "zoko who.txt -e exclude.txt " << endl 
            << "zoko who.txt -o   " << endl 
            << "zoko who.txt -p-  " << endl 
            << "zoko who.txt -q   " << endl 
            << "zoko who.txt -r-  " << endl 
            << "zoko who.txt -s-  " << endl 
            << "zoko who.txt -w   " << endl 
            << "zoko -V           " << endl 
            << "zoko -VC          " << endl;
    }

}

WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
    const int MERSENNE_TWISTER = 1;
    KUN_CODE kc;
    std::string command( ::GetCommandLine() );
    if( readFilesBeforeCreatingWindows(command) ) {
        mm->quit = false;
    } else {
        return 0;
    }

    kunCode = &kc;

    kc.defectiveCsv = true;
    kc.from_not_38 = false;
    kc.full_swing = false;
    kc.grouping = false;
    kc.mapping = false;
    kc.outputLines = KOPIC_REPEAT - KOPIC_FROM;
    kc.prng = MERSENNE_TWISTER;
    kc.weight = true;

    PICK_CODE pc = settingBeforehand(KOPIC_CSV, &kc);
    if(pc.code != UNPICKED) {
        return 0;
    }

    strcpy(CSVname, "who8765-43-21.csv");

    try
    {
         Application->Initialize();
         Application->HelpFile = "C:\\zokoVCL\\ZOKO.HLP";
         Application->Title = "Zoko";
         Application->CreateForm(__classid(TForm1), &Form1);
         Application->CreateForm(__classid(TOKHelpRightDlg), &OKHelpRightDlg);
         Application->CreateForm(__classid(TOKRightDlg1), &OKRightDlg1);
         Application->CreateForm(__classid(TOKBottomDlg), &OKBottomDlg);
         Application->Run();
    }
    catch (Exception &exception)
    {
         Application->ShowException(&exception);
    }
    return 0;
}
