#ifndef zokoMainH
#define zokoMainH

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Clipbrd.hpp>

class TForm1 : public TForm
{
__published:
    TMainMenu *MainMenu1;
    TMenuItem *File1;
    TMenuItem *Exit1;
    TStatusBar *StatusBar1;
    TPanel *Panel1;
    TButton *Button1;
    TButton *Button2;
    TMemo *Memo1;
    TMenuItem *Help1;
    TMenuItem *Version1;
    TMenuItem *Setting1;
    TMenuItem *Weight1;
    TTimer *Timer1;
    TMenuItem *CSV1;
    TMenuItem *Window1;
    TMenuItem *Large1;
    TMenuItem *Standard1;
    TMenuItem *Center1;
    TMenuItem *Corner1;
    TMenuItem *Diagonal1;
    TMenuItem *Right1;
    TMenuItem *Small1;
    TMenuItem *Under1;
    TMenuItem *Mark1;
    TMenuItem *Editor1;
    TMenuItem *Copy1;
    TMenuItem *N1;
    TMenuItem *Count1;
    TMenuItem *N2;
    TMenuItem *One1;
    TMenuItem *Two1;
    TMenuItem *Three1;
    TMenuItem *Four1;
    TMenuItem *Five1;
    TMenuItem *Six1;
    TMenuItem *Seven1;
    TMenuItem *Bonus1;
    TMenuItem *Three2;
    TMenuItem *Six2;
    TComboBox *ComboBox1;
    TMenuItem *Optional1;
    TMenuItem *Preediting1;
    TMenuItem *Minimize1;
    void __fastcall Exit1Click(TObject *Sender);
    void __fastcall Version1Click(TObject *Sender);
    void __fastcall Weight1Click(TObject *Sender);
    void __fastcall Timer1Timer(TObject *Sender);
    void __fastcall CSV1Click(TObject *Sender);
    void __fastcall FormResize(TObject *Sender);
    void __fastcall Button2Click(TObject *Sender);
    void __fastcall Large1Click(TObject *Sender);
    void __fastcall Standard1Click(TObject *Sender);
    void __fastcall StatusBar1Click(TObject *Sender);
    void __fastcall Center1Click(TObject *Sender);
    void __fastcall Corner1Click(TObject *Sender);
    void __fastcall Diagonal1Click(TObject *Sender);
    void __fastcall Right1Click(TObject *Sender);
    void __fastcall Small1Click(TObject *Sender);
    void __fastcall Under1Click(TObject *Sender);
    void __fastcall Editor1Click(TObject *Sender);
    void __fastcall Mark1Click(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall Copy1Click(TObject *Sender);
    void __fastcall Three2Click(TObject *Sender);
    void __fastcall Six2Click(TObject *Sender);
    void __fastcall One1Click(TObject *Sender);
    void __fastcall Two1Click(TObject *Sender);
    void __fastcall Three1Click(TObject *Sender);
    void __fastcall Four1Click(TObject *Sender);
    void __fastcall Five1Click(TObject *Sender);
    void __fastcall Six1Click(TObject *Sender);
    void __fastcall Seven1Click(TObject *Sender);
    void __fastcall Button1Click(TObject *Sender);
    void __fastcall Optional1Click(TObject *Sender);
    void __fastcall Preediting1Click(TObject *Sender);
    void __fastcall ComboBox1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall Minimize1Click(TObject *Sender);
private:
    bool checkBox, countBonus, csv, editor, firstLine, firstSession, grouping, mark, noSplitting, onlyTwo, preedit, produce_rannu_text, quit, serialNumber, showWhere, threeLinesUnited, whoCSV, whoText, zoko_h, zoko_w, zoko_x, zoko_y;
    const AnsiString TITLE;
    const bool IMPERFECT, PERFECT;
    const int BALLS, TEXT_AREA_NEW_LINE_LENGTH;
    const std::string CLOSE_BRACKET, DRAFO_CSV, EMPTY, GAP, m0, m1, m2, m3, m4, m5, m6, m7, m8, m9, m10, m11, m12, m13, m14, m15, m16, m17, m18, ZERO;
    int balls, csv_h, csv_w, csv_x, csv_y, interval_0, interval_1, itemCount, lineCount, prng, rowCount, standard_main_x, standard_main_y, untouched, whichCorner;
    long kilo, seed;
    OPTIONAL_CODE oc;
    std::string error, fileName, FULL_PATH_NAME, list_of_items, OPTIONAL_TEXT, pathName, statusBarText, TEXT_AREA_NEW_LINE, textName, whoTextLine1;
    std::string a[DRAW_ARRAY_SIZE];
    std::string draw[DRAW_ARRAY_SIZE];
    std::string m[ MANAGE_TEXT_LINE_COUNT + 1 ];

    bool CSVdialog();
    bool editCountBalls();
    bool optionalAdding();
    bool readManageText();
    bool saveLine1();
    bool setLine(int number);
    void centering();
    void checkManageMemory();
    void largeHandler();
    void memoText();
    void settingComboBox();
    void standardHeader(bool perfect);
    void statusBarMessage(std::string & s);
    void stringArrayToValues();
    void tracking();
    bool where();
public:		// [U[錾
    bool kopicCsvTouched();
    __fastcall TForm1(TComponent* Owner);
    bool header(std::string & fileName);
    void temporaryFileName(char *name);
};

extern PACKAGE TForm1 *Form1;

#endif
