#include <vcl.h>
#pragma hdrstop

#include "zokoVersion.h"

#pragma resource "*.dfm"
TOKHelpRightDlg *OKHelpRightDlg;

void TOKHelpRightDlg::setVersion(double d) {
    const AnsiString version("Version ");
    const AnsiString number(d);
    Label3->Caption = version + number;
}

__fastcall TOKHelpRightDlg::TOKHelpRightDlg(TComponent* AOwner)
	: TOKRightDlg(AOwner)
{
    Bevel1->Visible = false;
    CancelBtn->Left = VERSION_CLOSE_LEFT;
    Height = VERSION_HEIGHT;
    HelpBtn->Left = VERSION_WINDOWS_LEFT;
    Label1->Left = ZOKO_VCL_LEFT;
    Label1->Top = ZOKO_VCL_TOP;
    Label2->Left = COPYRIGHT_LEFT;
    Label2->Top = COPYRIGHT_TOP;
    Label3->Align = alBottom;
    Label3->AutoSize = false;
    Label3->Height = 30;
    OKBtn->Left = VERSION_HELP_LEFT;
    OKBtn->Top = VERSION_HELP_TOP;
    Width = VERSION_WIDTH;
}

void __fastcall TOKHelpRightDlg::HelpBtnClick(TObject *Sender)
{
//	Application->HelpContext(HelpContext);
    executeProgram(WINDOWS_HTML_HELP, "");
}

void __fastcall TOKHelpRightDlg::OKBtnClick(TObject *Sender)
{
    executeProgram(VIEW_PDF, "");
}
